#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=zPlayer.ico
#AutoIt3Wrapper_Res_Description=zPlayer by C. Y. Cho
#AutoIt3Wrapper_Res_Fileversion=6.1.0.8
#AutoIt3Wrapper_Outfile=zPlayer.exe
#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w 7
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <GUIConstants.au3>
#include <Array.au3>
#include <File.au3>
#include <Math.au3>
#include <WinAPISysWin.au3>
#include <WinAPIProc.au3>
#include <WinAPIDiag.au3>
#include <GuiListView.au3>
#include <MsgBoxConstants.au3>
#include <Misc.au3>
_Singleton("zPlayer")

Opt("GUICloseOnESC", 0)
Opt("MustDeclareVars", 1)
HotKeySet("^!{right}", "_PlayNext")			; Play next file
HotKeySet("^!{left}", "_PlayPrevious")		; Play previous file
HotKeySet("^!{up}", "_VolumeUp")			; Increase application volume level
HotKeySet("^!{down}", "_VolumeDown")		; Decrease application volume level

; Alternate hotkeys for Ctrl+Alt+Arrows if they are used by Windows for changing screen orientation
HotKeySet("^!{.}", "_PlayNext")				; Play next file
HotKeySet("^!{,}", "_PlayPrevious")			; Play previous file
HotKeySet("^!{=}", "_VolumeUp")				; Increase application volume level
HotKeySet("^!{-}", "_VolumeDown")			; Decrease application volume level

HotKeySet("^!{END}", "_Exit")				; Terminate the program
HotKeySet("^!u", "_Unload")					; Close current media and unload playlist
HotKeySet("^!p", "_Pause")					; Play/Pause
HotKeySet("^!s", "_Shuffle")				; Shuffle/Sort playlist
HotKeySet("^!m", "_Mute")					; Mute on/off
HotKeySet("^!r", "_Repeat")					; Repeat current file on/off
HotKeySet("^!h", "_Help")					; Show/Hide Help window
HotKeySet("^!l", "_PlaylistShow")			; View playlist and double click an item to play
HotKeySet("^!i", "_InternetSearch")			; Search the current title in internet
HotKeySet("^!f", "_FilePropertiesShow")		; View properties of current file
HotKeySet("{F11}", "_FullScreen")			; Fullscreen mode on/off
;HotKeySet("{ESC}", "_FullScreen")			; Fullscreen mode off, to be effective only when video is in fullscreen
HotKeySet("^!c", "_LoadFolder")				; Change folder
HotKeySet("^!w", "_WinDefaultPos")			; Move all GUIs to default positions and bring them to foreground

Global $iniFile = @ScriptDir & "\zPlayer.ini"
Global $sFolder = IniRead($iniFile, "Player", "Folder", @ScriptDir)
If StringRight($sFolder, 1) <> "\" Then $sFolder &= "\"
Global $sFileTypes = IniRead($iniFile, "Player", "File Types", "mp3 wav wma ogg ape flac asf mp4 wmv avi mkv flv webM cda")
If StringInStr($sFileTypes, "*.") Or Not StringInStr($sFileTypes, "cda") Then $sFileTypes = "mp3 wav wma ogg ape flac asf mp4 wmv avi mkv flv webM cda"
Global $iVolume = IniRead($iniFile, "Player", "Volume Level", 100)
If $iVolume > 100 Then $iVolume = 100
Global $sColNumbers = IniRead($iniFile, "Player", "File Property Column Numbers", "0,1,2,3,4,5,13,14,15,16,17,18,20,21,22,23,26,27,28,194,313,314,315,316,320")
; GetDetailsOf() column numbers for file properties (Vaild for Windows 10/11. Check for other OS versions.)
Global $resumeMode = IniRead($iniFile, "Resume Playback", "Mode", "Always")
Global $minTotalLength = IniRead($iniFile, "Resume Playback", "Minimum Total Length", 300)
Global $minPlaybackLength = IniRead($iniFile, "Resume Playback", "Minimum Playback Length", 100)
Global $iPlaying, $iPaused, $iRepeat, $iVideo, $iIndex
Global $aPos = WinGetPos("[Class:Shell_TrayWnd]")	; 0, 1032, 1920, 48
Global $scrHeight = $aPos[1], $scrWidth = $aPos[2], $borderWidth, $titleHeight, $iMaximizedTitleHeight
Global $sFiles, $aFiles, $sFile, $aFileInfo, $currentFileProperties, $sPath = "full path for file properties"
Global $iMarquee, $sTitle, $iTitleWidth, $iCharacters, $idVolume, $idABRepeat
Global $CDLabel, $iCDTracks, $iCDLength, $aTracks, $iTrack, $iTrackPos, $iTrackLength, $iTrackPlayedLength, $iCD

Global $hMain, $guiTitle = "zPlayer", $guiWidth = 320, $guiMsg, $idTitle, $idCurrentPos, $idSlider, $idProgBar, $idLength
Global $idShuffle, $idPlay, $idPrevious, $idRepeat, $idNext, $idSpeaker, $idUp, $idDown, $idFile, $idFolder, $idQuestionMark
Global $xOffset = 38, $progbarWidth = 10, $sliderLength = $guiWidth-$xOffset*2-$progbarWidth
$hMain = GUICreate($guiTitle, $guiWidth, 73, 0, 0)							; Main GUI
GUISetIcon(@ScriptDir & "\zPlayer.ico")
$idTitle = GUICtrlCreateLabel("Media title", 5, 5, $guiWidth-10, 18, $SS_NOPREFIX+$SS_LEFTNOWORDWRAP); Media title, marquee style
GUICtrlSetTip(-1, "Open/Close Playlist", "", 1, 1)
$idCurrentPos = GUICtrlCreateLabel("00.00", 2, 25, 35, 15, $SS_RIGHT)					; Current media position
GUICtrlSetTip(-1, "Open/Close A-B Repeat Settings", "", 1, 1)
$idSlider = GUICtrlCreateLabel("", $xOffset, 24, $sliderLength+$progbarWidth, 12)		; Slider
GUICtrlSetBkColor(-1, 0xD0D0D0)
$idABRepeat = GUICtrlCreateLabel("", $xOffset, 4, 10, 12)								; Pink bar to indicate A-B repeat positions in slider
GUICtrlSetBkColor(-1, 0xFFB3E6)
GUICtrlSetState(-1, $GUI_HIDE)
$idProgBar = GUICtrlCreateLabel("", 38, 24, $progbarWidth, 12)							; Progress bar
GUICtrlSetBkColor(-1, 0x656565)
$idLength = GUICtrlCreateLabel("00.00", 281, 25, 35, 15, $SS_LEFT)						; Media length
GUICtrlSetTip(-1, "Open/Close File Repeat Settings", "", 1, 1)
$idPlay = GUICtrlCreateLabel("❚❚", 58, 45, 16, 18, $SS_CENTER)							; Pause/Play
GUICtrlSetFont(-1, 18)
GUICtrlSetColor(-1, 0x656565)
$idPrevious = GUICtrlCreateLabel("◀", 77, 51, 15, 15, $SS_CENTER)						; Play previous file
GUICtrlSetFont(-1, 10)
GUICtrlSetColor(-1, 0x656565)
$idRepeat = GUICtrlCreateLabel("U", 90, 50, 15, 15, $SS_CENTER)							; Repeat(0)/No repeat(U)
GUICtrlSetFont(-1, 10, 900)
GUICtrlSetColor(-1, 0x656565)
$idNext = GUICtrlCreateLabel("▶", 105, 51, 15, 15, $SS_CENTER)							; Play next file
GUICtrlSetFont(-1, 10)
GUICtrlSetColor(-1, 0x656565)
$idSpeaker = GUICtrlCreateLabel("🔊", 122, 47, 16, 18, $SS_CENTER)						; Audio on/off
GUICtrlSetFont(-1, 15, 400)
GUICtrlSetColor(-1, 0x656565)
$idUp = GUICtrlCreateLabel("▲", 137, 44, 15, 15, $SS_CENTER)							; Volume up
GUICtrlSetFont(-1, 10)
GUICtrlSetColor(-1, 0x656565)
GUICtrlSetTip(-1, $iVolume)
$idDown = GUICtrlCreateLabel("▼", 137, 57, 15, 15, $SS_CENTER)							; Volume down
GUICtrlSetFont(-1, 10)
GUICtrlSetColor(-1, 0x656565)
GUICtrlSetTip(-1, $iVolume)
$idShuffle = GUICtrlCreateButton("Shuffle", 5, 45, 50, 24)								; Play at shuffled/sorted order
$idFile = GUICtrlCreateButton("Load File", 155, 45, 61, 24)								; Load files/Unload files or folder
$idFolder = GUICtrlCreateButton("Load Folder", 216, 45, 79, 24)							; Load/Change folder
$idQuestionMark = GUICtrlCreateButton("?", 295, 45, 20, 24)								; Help
GUICtrlSetFont(-1, 12, 600)
$idVolume = GUICtrlCreateButton($iVolume, 153, 33, 25, 25)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetState($idTitle, $GUI_DISABLE)
GUICtrlSetState($idSlider, $GUI_DISABLE)
GUICtrlSetState($idShuffle, $GUI_DISABLE)
GUICtrlSetState($idPlay, $GUI_DISABLE)
GUICtrlSetState($idPrevious, $GUI_DISABLE)
GUICtrlSetState($idRepeat, $GUI_DISABLE)
GUICtrlSetState($idNext, $GUI_DISABLE)
GUICtrlSetState($idSpeaker, $GUI_DISABLE)
GUISetState(@SW_SHOW, $hMain)

Global $videoWidth = @DesktopWidth/3*2, $videoHeight = $videoWidth*9/16, $iGui
Global $hVideoGUI = GUICreate("zPlayer", $videoWidth, $videoHeight, -1, -1, $WS_OVERLAPPEDWINDOW, -1, $hMain)    ; parent GUI of video window
GUISetIcon(@ScriptDir & "\zPlayer.ico")
GUISetBkColor(0, $hVideoGUI)
$iGui = Dec(StringMid($hVideoGUI, 3))
GUISetState(@SW_HIDE, $hVideoGUI)
$aPos = WinGetPos($hVideoGUI)
$borderWidth = ($aPos[2]-$videoWidth)/2
$titleHeight = $aPos[3]-$videoHeight-$borderWidth

Global $hDLL = DllOpen("winmm.dll")	; https://learn.microsoft.com/en-us/windows/win32/multimedia/multimedia-command-strings
If $hDLL = -1 Then Exit MsgBox($MB_OK, "DLL Open Failure", "winmm.dll could not be opened!")

Global $vcGUI, $imgHeight, $imgWidth, $imgRatio, $iLength, $hVideo, $vcWidth = $guiWidth, $vcHeight = 45, $vcLeft, $vcTop
Global $idFullScreen, $idExit, $idVolume2, $idCurrentPos2, $idSlider2, $idProgBar2, $idABRepeat2, $idSpeaker2
Global $idLength2, $idPlay2, $idPrevious2, $idRepeat2, $idNext2, $idUp2, $idDown2, $sliderLength2 = $sliderLength
$vcGUI = GUICreate("", $guiWidth, $vcHeight, $vcLeft, $vcTop, $WS_POPUP, $WS_EX_LAYERED, $hVideo)

Global $sHelp = zPlayerHelp()
Global $helpWidth = 800, $helpHeight = 570, $iHelp
Global $hHelp = GUICreate("The Funtions of zPlayer", $helpWidth, $helpHeight, -1, 0, $WS_SYSMENU, -1, $hMain)
GUISetIcon(@ScriptDir & "\zPlayer.ico")
GUISetFont(11, 400, "", "Arial", $hHelp)
Global $helpEdit = GUICtrlCreateEdit($sHelp, 13, 5, $helpWidth-34, $helpHeight-50, $WS_VSCROLL+$ES_READONLY)
ControlClick($hHelp, "", $helpEdit)

Global $hPlaylist, $ctrlView, $iListView
Global $listWidth = 485								; initial width of listview window
Global $listHeight = @DesktopHeight/2				; initial height of listview window
Global $listLeft = (@DesktopWidth-$listWidth)/2		; left of listview window
Global $listTop = 0									; top of listview window, to be defined in CreateWinListview()
Global $listMinimumWidth = $listWidth				; minimum width of listview window
Global $viewHeight = $listHeight-87					; initial height of listview control, to be defined in _PlaylistCreate()
Global $characterWidth = 6							; average character width in listview window
Global $headerHeight, $itemHeight					; heights of listview header and items to be defined in _PlaylistLoad()
Global $ctrlSearchBox, $ctrlFind, $ctrlNext, $ctrlRevert, $ctrlRescan, $ctrlReshuffle, $col1Width, $iDoubleClicked, $iRescanned
Global $idContextmenu, $idSubmenuPlay, $idSubmenuFileInfo, $idSubmenuSearch, $idSubmenuFolder, $idSubmenuRemove
Global $idPrefLabel1, $idPrefLabel2, $idPrefLabel3, $idPrefLabel4, $idPrefLabel5
Global $idPrefRadio1, $idPrefRadio2, $idPrefRadio3, $idPrefSave, $idPrefTotal, $idPrefPlayed
Global $iStyles = BitOR($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER, $LVS_REPORT, $LVS_SINGLESEL, $LVS_OWNERDATA)
Global $iStylesEx = BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_GRIDLINES, $LVS_EX_DOUBLEBUFFER)
_PlaylistCreate()

Global $aColNumbers = StringSplit($sColNumbers, ",", 2)
Global $iLenColNumber ; Coulmn number for media length property (27 for Windows 10/11)
Global $propertyWidth = 450, $propertyHeight = UBound($aColNumbers)*19+38, $nameWidth = 120
Global $hProperties, $idPropertiesView, $iProperties
$hProperties = GUICreate("File Properties", $propertyWidth, $propertyHeight, -1, 0, $WS_OVERLAPPEDWINDOW, -1, $hMain)
GUISetIcon(@ScriptDir & "\zPlayer.ico")
GUISetFont(9, 400, "", "Arial", $hProperties)
$idPropertiesView = GUICtrlCreateListView("Property|Value (Double-click to copy)", 5, 0, $propertyWidth-3, $propertyHeight-5, _
	BitOR($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER, $LVS_REPORT, $LVS_SINGLESEL), _
	BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_GRIDLINES))
GUICtrlSetResizing(-1, $GUI_DOCKBORDERS)
_GUICtrlListView_SetColumnWidth($idPropertiesView, 0, $nameWidth)
_GUICtrlListView_SetColumnWidth($idPropertiesView, 1, $propertyWidth-$nameWidth-15)

Global $hABRepeat, $iABRepeat, $iABRepeatWin, $ABRepeatWidth = 185, $iStart, $iEnd
$hABRepeat = GUICreate("", $ABRepeatWidth, 96, 0, 0, $WS_POPUPWINDOW, -1, $hMain)
$aPos = WinGetPos($hABRepeat)
GUICtrlCreateLabel("Set A-B Repeat Positions", 10, 8, 160, 15)
GUICtrlSetFont(-1, -1, -1,  $GUI_FONTUNDER)
GUICtrlCreateLabel("Start Position:", 10, 29, 80, 15)
GUICtrlCreateLabel("End Position:", 10, 49, 80, 15)
Global $idStart = GUICtrlCreateInput("", 95, 27, 40, 16, $SS_RIGHT)
GUICtrlSetLimit(-1, 6)
Global $idEnd = GUICtrlCreateInput("", 95, 47, 40, 16, $SS_RIGHT)
GUICtrlSetLimit(-1, 6)
GUICtrlCreateLabel("mm:ss", 137, 29, 45, 15)
GUICtrlCreateLabel("mm:ss", 137, 49, 45, 15)
Global $idApply = GUICtrlCreateButton("Apply", 30, 69, 50, 22)
Global $idHide = GUICtrlCreateButton("Close", 105, 69, 50, 22)
GUISetState(@SW_HIDE, $hABRepeat)

Global $hFilesRepeat, $iFilesRepeatWin, $sFilesToRepeat, $aFilesToRepeat[1]
$hFilesRepeat = GUICreate("", $ABRepeatWidth, 96, 0, 0, $WS_POPUPWINDOW, -1, $hMain)
GUICtrlCreateLabel("Enter item numbers of files to", 10, 10, 170, 15)
GUICtrlCreateLabel("repeat. (Example: 1,3-5,9-7)", 10, 27, 170, 15)
Global $idFiles = GUICtrlCreateInput("", 10, 47, 165, 16, $SS_LEFT)
Global $idFilesApply = GUICtrlCreateButton("Apply", 30, 69, 50, 22)
Global $idFilesHide = GUICtrlCreateButton("Close", 105, 69, 50, 22)
GUISetState(@SW_HIDE, $hFilesRepeat)

Global $fullscreenFrom, $filePropertiesFrom, $internetSearchFrom	; To differentiate function calls by control clicks from those by hotkeys

Global $tText = DllStructCreate( "wchar[256]" ), $aItems, $aColors[0][3]	; To be used by WM_NOTIFY() for virtual listview

Opt("TrayMenuMode", 3)
TrayCreateItem("zPlayer")
TrayCreateItem("")
Global $tray1 = TrayCreateItem("Exit")
TrayItemSetState($tray1, 4)

GUIRegisterMsg($WM_MOVE, "WM_MOVE")		; Detect movement of $hVideoGUI and adjust $hVideo/$vcGUI positions
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")	; Fill virtual listview/Create context menu in playlist window

;~ AdlibRegister("_Marquee", 500)		; Display title with long file name in marquee style
;~ AdlibRegister("_VCShow", 250)		; Show video control when mouse pointer enters the lower side of video window
;~ AdlibRegister("_VCResize", 500)		; Resize video control when video size changes
;~ AdlibRegister("_ProgressBar", 250)	; Display progress of playback, with graphics and text
;~ AdlibRegister("_FadeIn", 200)		; Simulate audio fade-in w/o interrupting the flow of program
;~ AdlibRegister("_GetLength", 25)		; Fill the Length column of playlist with media lengths in hh:mm:ss format
;~ AdlibRegister("_VolumeSync")			; If volume was changed via Windows Settings, sync $iVolume

Global $aMsg, $currentFile, $iRet, $sMsg, $sStr, $iLen, $iMaximized, $iFullScreen, $x, $y, $w, $h
Global $iMute, $iFolderLoaded, $iShuffled, $resumePosition, $iPlayListSaved
Global $oShellApp = ObjCreate("shell.application"), $iList, $iAllDone, $iDoing, $volumeStep

#Region		;**** Global variables for ISimpleAudioVolume Interface
Global Const $sCLSID_MMDeviceEnumerator = "{BCDE0395-E52F-467C-8E3D-C4579291692E}"
Global Const $sIID_IMMDeviceEnumerator = "{A95664D2-9614-4F35-A746-DE8DB63617E6}"
Global Const $sTagIMMDeviceEnumerator = _
        "EnumAudioEndpoints hresult(int;dword;ptr*);" & _
        "GetDefaultAudioEndpoint hresult(int;int;ptr*);" & _
        "GetDevice hresult(wstr;ptr*);" & _
        "RegisterEndpointNotificationCallback hresult(ptr);" & _
        "UnregisterEndpointNotificationCallback hresult(ptr)"

Global Const $sIID_IMMDevice = "{D666063F-1587-4E43-81F1-B948E807363F}"
Global Const $sTagIMMDevice = _
        "Activate hresult(struct*;dword;ptr;ptr*);" & _
        "OpenPropertyStore hresult(dword;ptr*);" & _
        "GetId hresult(wstr*);" & _
        "GetState hresult(dword*)"

Global Const $sIID_IAudioSessionManager2 = "{77aa99a0-1bd6-484f-8bc7-2c654c9a9b6f}"
Global Const $sTagIAudioSessionManager = "GetAudioSessionControl hresult(ptr;dword;ptr*);" & _
        "GetSimpleAudioVolume hresult(ptr;dword;ptr*);"
Global Const $sTagIAudioSessionManager2 = $sTagIAudioSessionManager & "GetSessionEnumerator hresult(ptr*);" & _
        "RegisterSessionNotification hresult(ptr);" & _
        "UnregisterSessionNotification hresult(ptr);" & _
        "RegisterDuckNotification hresult(wstr;ptr);" & _
        "UnregisterDuckNotification hresult(ptr)"

Global Const $sIID_IAudioSessionEnumerator = "{e2f5bb11-0570-40ca-acdd-3aa01277dee8}"
Global Const $sTagIAudioSessionEnumerator = "GetCount hresult(int*);GetSession hresult(int;ptr*)"

Global Const $sIID_IAudioSessionControl = "{f4b1a599-7266-4319-a8ca-e70acb11e8cd}"
Global Const $sTagIAudioSessionControl = "GetState hresult(int*);GetDisplayName hresult(ptr);" & _
        "SetDisplayName hresult(wstr);GetIconPath hresult(ptr);" & _
        "SetIconPath hresult(wstr;ptr);GetGroupingParam hresult(ptr*);" & _
        "SetGroupingParam hresult(ptr;ptr);RegisterAudioSessionNotification hresult(ptr);" & _
        "UnregisterAudioSessionNotification hresult(ptr);"

Global Const $sIID_IAudioSessionControl2 = "{bfb7ff88-7239-4fc9-8fa2-07c950be9c6d}"
Global Const $sTagIAudioSessionControl2 = $sTagIAudioSessionControl & "GetSessionIdentifier hresult(ptr)" & _
        "GetSessionInstanceIdentifier hresult(ptr);" & _
        "GetProcessId hresult(dword*);IsSystemSoundsSession hresult();" & _
        "SetDuckingPreferences hresult(bool);"

; http://answers.awesomium.com/questions/3398/controlling-the-sound-using-pinvoke-the-volume-mix.html
Global Const $sIID_ISimpleAudioVolume = "{87CE5498-68D6-44E5-9215-6DA47EF883D8}"
Global Const $sTagISimpleAudioVolume = _
        "SetMasterVolume hresult(float;ptr);" & _
        "GetMasterVolume hresult(float*);" & _
        "SetMute hresult(int;ptr);" & _
        "GetMute hresult(int*)"
Global $__oIAudioSessionManager2, $processName, $nTh, $gPID, $muteState

If @Compiled Then
	$processName = "zPlayer.exe"
	$nTh = 1
Else
	$processName = "AutoIt3.exe"
	$nTh = 2
EndIf
$gPID = _GetProcessID_by_name($processName, $nTh)
#EndRegion		;**** Global variables for ISimpleAudioVolume Interface

_LoadLastFolder()

While 1
	$aMsg = GUIGetMsg(1)
	$guiMsg = $aMsg[0]
	Switch $aMsg[1]
		Case $hMain, $vcGUI
			Switch $guiMsg
				Case $GUI_EVENT_CLOSE, $idExit
					_Exit()
				Case $GUI_EVENT_MINIMIZE
					If $iVideo = 1 Then
						WinSetState($hVideo, "", @SW_HIDE)
						GUISetState(@SW_HIDE, $vcGUI)
					EndIf
				Case $GUI_EVENT_RESTORE
					If $iVideo = 1 Then
						If $iMaximized = 1 Then	; A GUI loses maximized state when a hidden, maximized GUI gets displayed by a click on the process icon in taskbar
							GUISetState(@SW_MAXIMIZE, $hVideoGUI)
						EndIf
						WinSetState($hVideo, "", @SW_SHOW)
						GUISetState(@SW_SHOW, $vcGUI)
					Else
						GUISetState(@SW_HIDE, $hVideoGUI)
					EndIf
				Case $idFile
					If GUICtrlRead($idFile) = "Unload" Then
						_Unload()
					Else
						_LoadFiles()
					EndIf
				Case $idFolder
					_LoadFolder()
				Case $idPlay, $idPlay2
					_Pause()
				Case $idPrevious, $idPrevious2
					_PlayPrevious()
				Case $idNext, $idNext2
					_PlayNext()
				Case $idSpeaker, $idSpeaker2
					_Mute()
				Case $idUp, $idUp2
					While _IsPressed("01") = 1	; Left mouse button
						_VolumeUp()
					WEnd
				Case $idDown, $idDown2
					While _IsPressed("01") = 1	; Left mouse button
						_VolumeDown()
					WEnd
				Case $idShuffle
					If $iTrack = 0 Then
						_Shuffle()
					Else
						If GUICtrlRead($idShuffle) = "Sort" Then
							_ArraySort($aFiles, 0, 2)
							$iShuffled = 0
						Else
							Local $sList, $sShuffle = 1
							If $iFolderLoaded = 1 Then
								$iTrack = _CDCheck($sFolder, $aTracks, $aFiles)
								If $iTrack > 0 Then
									$sList = IniRead($iniFile, "Audio CD", "Playlist", "")
									If $sList <> "" Then
										$aFiles = StringSplit($sList, "|")
										_ArrayInsert($aFiles, 1, $currentFile)
										$aFiles[0] += 1
										_ArrayColInsert($aFiles, 1)
										$sShuffle = 0
									EndIf
								EndIf
							EndIf
							$iShuffled = 1
							If $sShuffle = 1 Then
								_ArrayShuffle($aFiles, 2)
								$iTrack = 1
								_PlaylistSave()
							EndIf
						EndIf
						_PlaylistLoad()
					EndIf
				Case $idTitle
					_PlaylistShow()
				Case $idRepeat, $idRepeat2
					_Repeat()
				Case $idQuestionMark
					_Help()
				Case $idFullScreen
					$fullscreenFrom = "VideoControl"
					_FullScreen()
					$fullscreenFrom = ""
				Case $idSlider, $idSlider2
					_Slider($aMsg[1])
				Case $idCurrentPos, $idCurrentPos2
					If $iVideo = 1 Then
						If $iMaximized = 1 Then
							$iFullScreen = 1
						EndIf
						If $iFullScreen = 1 Then
							$iMaximized = 0
							_FullScreen()
							$iABRepeatWin = 0
						EndIf
					EndIf
					If $iABRepeatWin = 0 Then
						GUISetState(@SW_HIDE, $hFilesRepeat)
						$iFilesRepeatWin = 0
						$aPos = WinGetPos($hMain)
						$w = ($aPos[2]-$guiWidth)/2
						If $aPos[0]+$guiWidth+$ABRepeatWidth+$w <= $scrWidth Then
							WinMove($hABRepeat, "", $aPos[0]+$guiWidth+$w, $aPos[1]+1)
						Else
							WinMove($hABRepeat, "", $aPos[0]-$ABRepeatWidth, $aPos[1]+1)
						EndIf
						GUISetState(@SW_SHOW, $hABRepeat)
						If $iABRepeat = 0 Then
							GUICtrlSetState($idStart, $GUI_FOCUS)
						Else
							GUICtrlSetState($idApply, $GUI_FOCUS)
						EndIf
						$iABRepeatWin = 1
					Else
						GUISetState(@SW_HIDE, $hABRepeat)
						$iABRepeatWin = 0
					EndIf
				Case $idLength, $idLength2
					If $iVideo = 1 Then
						If $iMaximized = 1 Then
							$iFullScreen = 1
						EndIf
						If $iFullScreen = 1 Then
							$iMaximized = 0
							_FullScreen()
							$iFilesRepeatWin = 0
						EndIf
					EndIf
					If $iFilesRepeatWin = 0 Then
						GUISetState(@SW_HIDE, $hABRepeat)
						$iABRepeatWin = 0
						$aPos = WinGetPos($hMain)
						$w = ($aPos[2]-$guiWidth)/2	; $border width of main GUI
						If $aPos[0]+$guiWidth+$ABRepeatWidth+$w <= $scrWidth Then
							WinMove($hFilesRepeat, "", $aPos[0]+$guiWidth+$w, $aPos[1]+1)
						Else
							WinMove($hFilesRepeat, "", $aPos[0]-$ABRepeatWidth, $aPos[1]+1)
						EndIf
						GUISetState(@SW_SHOW, $hFilesRepeat)
						$iFilesRepeatWin = 1
						If $sFilesToRepeat = "" Then
							GUICtrlSetState($idFiles, $GUI_FOCUS)
						Else
							GUISetState($idFilesApply, $GUI_FOCUS)
						EndIf
					Else
						GUISetState(@SW_HIDE, $hFilesRepeat)
						$iFilesRepeatWin = 0
						GUICtrlSetState($idFolder, $GUI_FOCUS)
					EndIf
			EndSwitch
		Case $hVideoGUI
			Switch $guiMsg
				Case $GUI_EVENT_CLOSE
					mciSendString("stop myMedia")
				Case $GUI_EVENT_MAXIMIZE
					; $x = -$borderWidth; $y = -$borderWidth; $w = @DesktopWidth+$borderWidth*2; $h = $scrHeight+$borderWidth
					$iMaximized = 1
					_MaximizeScreen()
				Case $GUI_EVENT_RESIZED
					If $iFullScreen = 0 And $iMaximized = 0 Then
						$aPos = WinGetPos($hVideoGUI)
						_VideoResize($aPos[2]-$borderWidth*2)
					EndIf
				Case $GUI_EVENT_RESTORE
					If $iMaximized = 1 And WinGetState($hMain) < 23 Then	; If $hMain is not in minimized state
						_VideoResize(Int(@DesktopWidth/3*2))
						$iMaximized = 0
					EndIf
			EndSwitch
		Case $hPlaylist
			_PlaylistMsg()
		Case $hProperties
			Switch $aMsg[0]
				Case $GUI_EVENT_CLOSE
					GUISetState(@SW_HIDE, $hProperties)
					$iProperties = 0
				Case $GUI_EVENT_RESIZED
					$aPos = WinGetClientSize($hProperties)
					_GUICtrlListView_SetColumnWidth($idPropertiesView, 1, $aPos[0]-$nameWidth-15)
			EndSwitch
		Case $hHelp
			Switch $aMsg[0]
				Case $GUI_EVENT_CLOSE
					GUISetState(@SW_HIDE, $hHelp)
					$iHelp = 0
			EndSwitch
		Case $hABRepeat
			_ABRepeatMsg()
		Case $hFilesRepeat
			_FileRepeatMsg()
	EndSwitch
	If TrayGetMsg() = $tray1 Then _Exit()

	If $idContextmenu <> "" Then	; Prevent memory leakage and flickering playlist
		_DeleteContextMenu()		; Context menu already got item id in _PlaylistMsg() above
	EndIf

	If $iPlaying = 0 Then ContinueLoop

	If $iABRepeat = 1 Then
		Local $iSec = mciSendString("status myMedia position")
		If $iTrack = 0 Then
			If Int($iSec/1000) >= $iEnd Then
				mciSendString("stop myMedia")
				mciSendString("play myMedia from " & $iStart*1000)
			EndIf
		Else
			If $iSec >= $iTrackPos + $iEnd*1000 Then
				mciSendString("stop myMedia")
				mciSendString("seek myMedia to " & $iTrackPos+$iStart*1000)
				mciSendString("play myMedia")
			EndIf
		EndIf
	EndIf

	If $iTrack > 0 Then
		If $iPaused = 1 Then
			ContinueLoop
		ElseIf Int(mciSendString("status myMedia position")/1000) >= Int(($iTrackPos+$iLength)/1000) Then
			mciSendString("stop myMedia")
		EndIf
	EndIf
	If mciSendString("status myMedia mode") <> "stopped" Then ContinueLoop

	If $iRepeat = 1 Then
		If $iTrack = 0 Then
			mciSendString("play myMedia from 50")
		Else
			mciSendString("play myMedia from " & $iTrackPos)
		EndIf
		ContinueLoop
	EndIf

	If $iTrack = 0 Then
		mciSendString("close myMedia")
	EndIf
	If $iFullScreen = 0 And $iMaximized = 0 Then	; Keep the background screen black when window is in maximized or fullscreen mode
		GUISetState(@SW_HIDE, $hVideoGUI)
	EndIf
	AdlibUnRegister("_Marquee")
	AdlibUnRegister("_ProgressBar")
	AdlibUnRegister("_VolumeSync")
	GUICtrlSetData($idTitle, "Media title")
	GUICtrlSetData($idCurrentPos, "00:00")
	GUICtrlSetData($idCurrentPos2, "00:00")
	GUICtrlSetData($idLength, "00:00")
	GUICtrlSetData($idLength2, "00:00")
	_ABRepeatCancel(1)

	While 1
		If $iRescanned <> 1 Then
			$iIndex += 1
		Else
			$iRescanned = 0	; If $currentFile not found in rescanned playlist, $iIndex becomes 2 per _PlaylistLoad()
		EndIf
		If $iIndex > $aFiles[0][0] Then
			$iIndex = 2
		ElseIf $iIndex < 2 Then
			$iIndex = $aFiles[0][0]
		EndIf

		If $aFilesToRepeat[0] > 0 Then
			For $i = 1 To $aFilesToRepeat[0]
				If $aFilesToRepeat[$i] >= $iIndex-1 Then
					ExitLoop
				EndIf
			Next
			If $i > $aFilesToRepeat[0] Then
				$iIndex = $aFilesToRepeat[1]+1
			Else
				$iIndex = $aFilesToRepeat[$i]+1
			EndIf
		EndIf

		If StringInStr($aFiles[$iIndex][0], ":\") Then
			$sFile = $aFiles[$iIndex][0]
		Else
			$sFile = $sFolder & $aFiles[$iIndex][0]
		EndIf
		If FileExists($sFile) Then
			If $iTrack > 0 Then ExitLoop

			$iRet = mciSendString("open """ & $sFile & """ alias myMedia type MPEGVideo wait style popup parent " & $iGui)
			If $iRet = 1 Then ExitLoop

			$sMsg = $sFile & @CRLF & @CRLF
			$sMsg &= "This file cannot be opened by this player." & @CRLF
			$sMsg &= "Please check if proper codec is installed." & @CRLF & @CRLF
			$sMsg &= "This file will be skipped."
			MsgBox($MB_OK, "Open error", $sMsg)
			ContinueLoop
		Else
			$sMsg = $sFile & @CRLF & @CRLF
			$sMsg &= "This file does not exist." & @CRLF
			$sMsg &= "This file will be skipped."
			MsgBox($MB_OK, "Open error", $sMsg)
			ContinueLoop
		EndIf
	WEnd
	$iPlaying = 0
	$iPaused = 0

	_Play()

WEnd

Func _ABRepeatMsg()	; Respond to GUIGetMsg() from $hABRepeat window
	Local $start, $end, $min, $sec, $i
	Switch $aMsg[0]
		Case $idStart		; Define starting position
			$start = GUICtrlRead($idStart)
			If $start = "" Then Return
			For $i = 1 To StringLen($start)
				If Not StringInStr("0123456789:", StringMid($start, $i, 1)) Then
					GUICtrlSetData($idStart, "")
					Return
				EndIf
			Next
			$i = StringInStr($start, ":")
			If $i > 0 Then
				$start = StringLeft($start, $i-1)*60+StringMid($start, $i+1)
			EndIf
			If $start >= Int($iLength /1000) Then
				GUICtrlSetData($idStart, "")
				Return
			EndIf
			$min = Int($start/60)
			$sec = StringFormat("%02i", $start-$min*60)
			GUICtrlSetData($idStart, $min & ":" & $sec)
			GUICtrlSetState($idEnd, $GUI_FOCUS)
		Case $idEnd			; Define ending position
			$end = StringStripWS(GUICtrlRead($idEnd), 8)
			If $end = "" Then
				GUICtrlSetData($idEnd, "")
				GUICtrlSetState($idEnd, $GUI_FOCUS)
				Return
			EndIf
			For $i = 1 To StringLen($end)
				If Not StringInStr("0123456789:", StringMid($end, $i, 1)) Then
					GUICtrlSetData($idEnd, "")
					Return
				EndIf
			Next
			$i = StringInStr($end, ":")
			If $i > 0 Then
				$end = StringLeft($end, $i-1)*60+StringMid($end, $i+1)
			EndIf
			If $end >= Int($iLength /1000) Then
				$end = Int($iLength /1000)
			EndIf
			If $start >= $end Then
				GUICtrlSetData($idStart, "")
				GUICtrlSetData($idEnd, "")
				GUICtrlSetState($idStart, $GUI_FOCUS)
				Return
			EndIf
			$min = Int($end/60)
			$sec = StringFormat("%02i", $end-$min*60)
			GUICtrlSetData($idEnd, $min & ":" & $sec)
			GUICtrlSetState($idApply, $GUI_FOCUS)
		Case $idApply
			If GUICtrlRead($idApply) = "Apply" Then		; Apply A-B repeat function
				$iStart = GUICtrlRead($idStart)
				If $iStart = "" Then
					GUICtrlSetState($idStart, $GUI_FOCUS)
					Return
				EndIf
				$i = StringInStr($iStart, ":")
				If $i > 0 Then
					$iStart = StringLeft($iStart, $i-1)*60+StringMid($iStart, $i+1)
				EndIf
				$iEnd = GUICtrlRead($idEnd)
				If $iEnd = "" Then
					GUICtrlSetState($idEnd, $GUI_FOCUS)
					Return
				EndIf
				$i = StringInStr($iEnd, ":")
				If $i > 0 Then
					$iEnd = StringLeft($iEnd, $i-1)*60+StringMid($iEnd, $i+1)
				EndIf
				If $iStart >= $iEnd Then
					GUICtrlSetData($idStart, "")
					GUICtrlSetData($idEnd, "")
					GUICtrlSetState($idStart, $GUI_FOCUS)
					Return
				EndIf
				GUICtrlSetData($idApply, "Cancel")
				GUICtrlSetTip($idApply, "Stop A-B repeat function.", "", 1, 1)
				GUICtrlSetPos($idABRepeat, $xOffset+$sliderLength/$iLength*$iStart*1000, 24, $sliderLength/$iLength*($iEnd-$iStart)*1000+$progbarWidth)
				GUICtrlSetPos($idABRepeat2, $sliderLength2/$iLength*$iStart*1000, 2, $sliderLength2/$iLength*($iEnd-$iStart)*1000+$progbarWidth)
				GUICtrlSetState($idABRepeat, $GUI_SHOW)
				GUICtrlSetState($idABRepeat2, $GUI_SHOW)
				GUICtrlSetColor($idCurrentPos, 0xFF0055)
				GUICtrlSetColor($idCurrentPos2, 0xFF0055)
				GUICtrlSetState($idStart, $GUI_DISABLE)
				GUICtrlSetState($idEnd, $GUI_DISABLE)
				$iABRepeat = 1
				$start = 0
				$end = 0
			ElseIf GUICtrlRead($idApply) = "Cancel" Then		; Cancel A-B repeat function
				_ABRepeatCancel(0)
			EndIf
			GUICtrlSetState($idHide, $GUI_FOCUS)
		Case $idHide		; Hide window
			GUISetState(@SW_HIDE, $hABRepeat)
			$iABRepeatWin = 0
	EndSwitch
EndFunc		;==>_ABRepeatMsg

Func _ABRepeatCancel($iHide)	; Cancel AB repeat setup
	If $iHide = 1 Then	; When moving to a different file or unloading the playlist
		GUISetState(@SW_HIDE, $hABRepeat)
		$iABRepeatWin = 0
	EndIf
	GUICtrlSetState($idABRepeat, $GUI_HIDE)
	GUICtrlSetState($idABRepeat2, $GUI_HIDE)
	GUICtrlSetColor($idCurrentPos, 0)
	GUICtrlSetColor($idCurrentPos2, 0)
	GUICtrlSetData($idApply, "Apply")
	GUICtrlSetTip($idApply, "Start A-B repeat function.", "", 1, 1)
	GUICtrlSetData($idStart, "")
	GUICtrlSetData($idEnd, "")
	GUICtrlSetState($idStart, $GUI_ENABLE)
	GUICtrlSetState($idEnd, $GUI_ENABLE)
	GUICtrlSetState($idStart, $GUI_FOCUS)
	$iStart = 0
	$iEnd = 0
	$iABRepeat = 0
EndFunc		;==>_ABRepeatCancel

Func _CDCheck($folder, $tracks, $array)	; Check if currently mounted CD is the same as the one stored in zPlayer.ini
	Local $CDID, $aCDID, $track = 0
	If $iTrack = 0 Then
		$iRet = mciSendString("open """ & $folder & """ alias myMedia type cdaudio wait")
		If $iRet <> 1 Then Return 0
	EndIf

	$CDID = IniRead($iniFile, "Audio CD", "CDID", "")
	If StringInStr($CDID, "|", 0, 3) > 0 Then
		$aCDID = StringSplit($CDID, "|")
		mciSendString("set myMedia time format milliseconds")
		; Check if number of tracks, total length of CD and the length of a particular track are the same
		If mciSendString("status myMedia number of tracks") = $aCDID[1] And _
			mciSendString("status myMedia length") = $aCDID[2] And _
			mciSendString("status myMedia length track " & $aCDID[3]) = $aCDID[4] And _
			Number($aCDID[1]) >= Number($aCDID[3]) And _ArraySearch($array, $tracks[$aCDID[3]]) Then
			$track = $aCDID[3]
		EndIf
	EndIf
	If $iTrack = 0 Then
		mciSendString("close myMedia")
	EndIf
	Return $track
EndFunc		;==>_CDCheck

Func _DeleteContextMenu()	; If not deledted after use of context menu, the playlist may flicker randomly
	GUICtrlDelete($idContextmenu)
	GUICtrlDelete($idSubmenuPlay)
	GUICtrlDelete($idSubmenuFileInfo)
	GUICtrlDelete($idSubmenuSearch)
	GUICtrlDelete($idSubmenuFolder)
	GUICtrlDelete($idSubmenuRemove)
	$idContextmenu = ""
EndFunc		;==>_DeleteContextMenu

Func _Exit()	; Terminate the program (Click main GUI Close button or 🞭 button on video control GUI, or press Ctrl+Alt+End)\
	_IniSave()
	_PlaylistSave()
	mciSendString("close myMedia")
	If $iMute = 1 Then _Mute()
	GUIDelete($hVideoGUI)	; Avoid possibility of black fullscreen remaining after termination of program
	DllClose($hDLL)
	_WinAPI_SetThreadExecutionState($ES_CONTINUOUS)	; Back to normal windows behavior
	Exit
EndFunc		;==>_Exit

Func _FadeIn()	; Simulation of audio fade-in: Use adlib to avoid Sleep() during gradual increase of volume in 4 seconds
	Local $aRet = DllCall($hDLL, "int", "waveOutGetVolume", "ptr", 0, "DWORD*", 0)
	Local $oldVolume = $aRet[2]
	Local $newVolume = Int(_Min($oldVolume+655.35*$volumeStep, $iVolume*655.35))
	DllCall($hDLL, "int", "waveOutSetVolume", "int", 0 , "int", $newVolume)
	If $newVolume >= Int($iVolume*655.35) Then
		AdlibUnRegister("_FadeIn")
		AdlibRegister("_VolumeSync")
	EndIf
EndFunc		;==>_FadeIn

Func _FilePropertiesGet()	; Obtian properties of file
	; This process will take  less than 250 milliseconds for most of the file types, but a large mp4 moive file may take up to 2 seconds
	If $sPath = "" Then Return
	Local $sFileName, $sDir, $oDir, $oFile, $sPropertyName, $sPropertyValue
	$sFileName = StringMid($sPath, StringInStr($sPath, "\", 0, -1)+1)
	$sDir = StringLeft($sPath, StringInStr($sPath, "\", 0, -1))
	$oDir = $oShellApp.NameSpace($sDir)
	$oFile = $oDir.Parsename($sFileName)
	$aFileInfo = ""
	Dim $aFileInfo [UBound($aColNumbers)][2]
	For $i = 0 To UBound($aColNumbers)-1
		$sPropertyName = $oDir.GetDetailsOf("", $aColNumbers[$i])
		$sPropertyValue = $oDir.GetDetailsOf($oFile, $aColNumbers[$i])
		$aFileInfo[$i][0] = $sPropertyName
		$aFileInfo[$i][1] = $sPropertyValue
		If $iLenColNumber = 0 And StringRegExp($sPropertyValue, "\d\d:\d\d:\d\d") Then
			$iLenColNumber = $aColNumbers[$i]
		EndIf
	Next
EndFunc		;==>_FilePropertiesGet

Func _FilePropertiesShow()	; View the file properties, Atrl+Alt+f or playlist context menu
	If $iPlaying = 0 Then Return
	If $iProperties = 1 And $filePropertiesFrom = "" Then	; This If...Endif clause is executed only when hotkey has been pressed
		GUISetState(@SW_HIDE, $hProperties)
		$iProperties = 0
		Return
	EndIf
	If $iFullScreen = 1 Then	; If video is in fullscreen mode, maximize it
		$iMaximized = 1
		_FullScreen()
	EndIf

	_GUICtrlListView_DeleteAllItems($idPropertiesView)
	If $filePropertiesFrom <> "" Then
		Local $tFile = $aFiles[$filePropertiesFrom+2][0]
		If StringInStr($tFile, ":\") Then
			$sPath = $tFile
		Else
			$sPath = $sFolder & $tFile
		EndIf
		_FilePropertiesGet()
		_GUICtrlListView_AddArray($idPropertiesView, $aFileInfo)
		$aPos = WinGetPos($hPlaylist)
		WinMove($hProperties, "", $aPos[0]+$aPos[2]/2, 0)
	Else
		_GUICtrlListView_AddArray($idPropertiesView, $currentFileProperties)
		If $iListView = 0 Then
			$aPos = WinGetPos($hProperties)
			WinMove($hProperties, "", (@DesktopWidth-$aPos[2])/2, 0)
		Else
			$aPos = WinGetPos($hPlaylist)
			WinMove($hProperties, "", $aPos[0]+$aPos[2]/2, 0)
		EndIf
	EndIf
	GUISetState(@SW_SHOW, $hProperties)
	WinActivate($hProperties)
	$iProperties = 1
EndFunc		;==>_FilePropertiesShow

Func _FileRepeatMsg()	; Respond to GUIGetMsg() from $hFilesRepeat
	Switch $aMsg[0]
		Case $idFiles
			GUICtrlSetState($idFilesApply, $GUI_FOCUS)
		Case $idFilesApply
			If GUICtrlRead($idFilesApply) = "Apply" Then
				$sFilesToRepeat = GUICtrlRead($idFiles)
				If $sFilesToRepeat = "" Then Return

				$sFilesToRepeat = StringStripWS($sFilesToRepeat, 8)
				Local $aTemp = StringSplit($sFilesToRepeat, ","), $sTemp = ","
				For $i = 1 To $aTemp[0]
					If StringInStr($aTemp[$i], "-") Then
						Local $iFrom = Number(StringLeft($aTemp[$i], StringInStr($aTemp[$i], "-")-1))
						Local $iTo = Number(StringMid($aTemp[$i], StringInStr($aTemp[$i], "-", 0, -1)+1))
						If $iTo >= $iFrom Then
							For $j = $iFrom To $iTo
								If $j >= $aFiles[0][0] Or StringInStr($sTemp, "," & $j & ",") Then ContinueLoop
								$sTemp &= $j & ","
							Next
						Else
							For $j = $iFrom To $iTo Step -1
								If $j >= $aFiles[0][0] Or StringInStr($sTemp, "," & $j & ",") Then ContinueLoop
								$sTemp &= $j & ","
							Next
						EndIf
					Else
						If $aTemp[$i] >= $aFiles[0][0] Or StringInStr($sTemp, "," & $aTemp[$i] & ",") Then ContinueLoop
						$sTemp &= $aTemp[$i] & ","
					EndIf
				Next
				If $sTemp == "," Then
					MsgBox(0, "", "Invalid item numbers!", 3)
					Return
				EndIf
				$sTemp = StringTrimRight(StringTrimLeft($sTemp, 1), 1)
				$aFilesToRepeat = StringSplit($sTemp, ",")

				;_ABRepeatCancel(0)	; Uncomment this line if you want to cancel A-B repeat when multi-file repeat is started
				$iPlaying = 0
				If $iPaused = 1 Then
					_Pause()
				EndIf
				For $i = 1 To $aFilesToRepeat[0]
					$aFilesToRepeat[$i] = Number($aFilesToRepeat[$i])
				Next
				_ArraySort($aFilesToRepeat, 0, 1)
				$sFilesToRepeat = ","
				For $i = 1 To $aFilesToRepeat[0]
					$sFilesToRepeat &= $aFilesToRepeat[$i] & ","
				Next
				Local $sColSet = _WinAPI_SwitchColor(0xFFB3E6)	; Convert RGB to BGR
				For $i = 0 To UBound($aItems)-1
					If StringInStr($sFilesToRepeat, "," & $i+1 & ",") Then
						For $j = 0 To 2
							$aColors[$i][$j] = $sColSet	; Background color for files to be repeated will be pink
						Next
						GUICtrlSendMsg($ctrlView, $LVM_UPDATE, $i, 0)
					EndIf
				Next
				_PlaylistHighlight()
				GUICtrlSetState($idShuffle, $GUI_DISABLE)
				GUICtrlSetState($ctrlRescan, $GUI_DISABLE)
				GUICtrlSetState($ctrlReshuffle, $GUI_DISABLE)

				If Not StringInStr($sFilesToRepeat, "," & $iIndex-1 & ",") Then
					$iIndex = $aFilesToRepeat[1]
					mciSendString("stop myMedia")
				EndIf
				GUICtrlSetData($idFilesApply, "Cancel")
				GUICtrlSetTip($idFilesApply, "Stop multi-file repeat function.", "", 1, 1)
				GUICtrlSetColor($idLength, 0xFF0055)
				GUICtrlSetColor($idLength2, 0xFF0055)
			Else
				_FileRepeatCancel("_FileRepeat")
			EndIf
			$iPlaying = 1
			GUICtrlSetState($idFilesHide, $GUI_FOCUS)
		Case $idFilesHide
			GUISetState(@SW_HIDE, $hFilesRepeat)
			$iFilesRepeatWin = 0
	EndSwitch
EndFunc		;==>_FileRepeatMsg

Func _FileRepeatCancel($sFrom)	; Cancel multi-file repeat set-up and relaoa playlist
	If $sFrom <> "_FileRepeat" Then	; When unloading the playlist or moving to a different folder
		GUISetState(@SW_HIDE, $hFilesRepeat)
		$iFilesRepeatWin = 0
		GUICtrlSetData($idFiles, "")
	EndIf
	Local $sColSet = 0xFFFFFF
	For $i = 0 To UBound($aItems)-1
		If StringInStr($sFilesToRepeat, "," & $i+1 & ",") Then
			For $j = 0 To 2
				$aColors[$i][$j] = $sColSet	; Background color of files repeated will be restored to white
			Next
			GUICtrlSendMsg($ctrlView, $LVM_UPDATE, $i, 0)
		EndIf
	Next
	If $sFrom <> "_Unload_1" Then
		_PlaylistHighlight()
	EndIf
	GUICtrlSetState($idShuffle, $GUI_ENABLE)
	If $iFolderLoaded = 1 And Not StringInStr($aFiles[1][0], ":\") Then
		GUICtrlSetState($ctrlRescan, $GUI_ENABLE)
	EndIf
	If $iShuffled = 1 Then
		GUICtrlSetState($ctrlReshuffle, $GUI_ENABLE)
	EndIf
	$sFilesToRepeat = ""
	$aFilesToRepeat[0] = 0
	ReDim $aFilesToRepeat[1]
	GUICtrlSetData($idFilesApply, "Apply")
	GUICtrlSetTip($idFilesApply, "Start multi-file repeat function.", "", 1, 1)
	GUICtrlSetColor($idLength, 0)
	GUICtrlSetColor($idLength2, 0)
EndFunc		;==>_FileRepeatCancel

Func _FullScreen()	; Video in fullscreen mode on/off (Click ⇔/⇙ icon in the graphicalcal control or press F11 hotkey)
	If $fullscreenFrom <> "VideoControl" Then	; This If...Endif clause is executed only when hotkey has been pressed
		If WinExists($hVideo) = 0 Or WinGetState($hVideo) < 7 Then Return
		$aPos = WinGetPos($hVideo)
		Local $tStruct = DllStructCreate($tagPOINT)
		DllStructSetData($tStruct, "x", $aPos[0]+$aPos[2]/2)
		DllStructSetData($tStruct, "y", $aPos[1]+$aPos[3]/2)
		Local $hWnd = _WinAPI_WindowFromPoint($tStruct)
		If WinGetTitle($hWnd) <> "ActiveMovie Window" Then Return
	EndIf
	If $iFullScreen = 0 Then
		$iFullScreen = 1
		_WinAPI_SetLayeredWindowAttributes($vcGUI, 0xABCDEF, 0)
		If $iPaused = 1 And $iMaximized = 0 Then	; This ensures full stretch of video image while media is paused.
			_MaximizeScreen()
		EndIf
		GUICtrlSetData($idFullScreen, "⇙")
		GUICtrlSetFont($idFullScreen, 20, 600)
		$x = -$borderWidth
		$y = 0
		$w = @DesktopWidth+$borderWidth*2
		$h = @DesktopHeight+$borderWidth
		GUISetStyle($WS_POPUP, -1, $hVideoGUI)
		WinMove($hVideoGUI, "", $x, $y, $w, $h)	; Not required for fullscreen, but needed to keep the screen black while moving to next file
		WinSetOnTop($hVideoGUI, "", 1)
		$videoWidth = @DesktopWidth
		$videoHeight = Int($videoWidth/$imgRatio)
		If $videoHeight > @DesktopHeight Then
			$videoHeight = @DesktopHeight
			$videoWidth = Int($videoHeight*$imgRatio)
		EndIf
		$w = $videoWidth
		$h = $videoHeight
		$x = (@DesktopWidth-$videoWidth)/2
		$y = (@DesktopHeight-$videoHeight)/2
		WinMove($hVideo, "", $x, $y, $w, $h)
		GUICtrlSetData($idSlider2, "  " & StringStripWS($sTitle, 2))
		HotKeySet("{ESC}", "_FullScreen")
	Else
		$iFullScreen = 0
		GUICtrlSetData($idFullScreen, "⇔")
		GUICtrlSetFont($idFullScreen, 12, 600)
		GUISetStyle($WS_OVERLAPPEDWINDOW, -1, $hVideoGUI)
		WinSetOnTop($hVideoGUI, "", 0)
		If $iMaximized = 1 Then
			GUISetState(@SW_MAXIMIZE, $hVideoGUI)
			_MaximizeScreen()
		Else
			_VideoResize(Int(@DesktopWidth/3*2))	; Revert to default video size even if it had been resized when entering fullscreen
		EndIf
		GUICtrlSetData($idSlider2, "")
		HotKeySet("{ESC}")
	EndIf
EndFunc		;==>_FullScreen

Func _GetLength()	; Adlib function to obtain media length at 25 ms interval
	If $iDoing = 1 Or $iAllDone = 1 Then Return
	$iDoing = 1
	Local $iHours, $iMinutes, $iSeconds, $tString, $tSeconds, $sText

	For $iList = 2 To $aFiles[0][0]
		If $aFiles[$iList][1] = "" Then	; Find an item, media length column of which is empty
			ExitLoop
		EndIf
	Next
	If $iList > $aFiles[0][0] Then	; When all media length fields are filled, total playlist length is calculated
		AdlibUnRegister("_GetLength")
		$iAllDone = 1
		$iDoing = 0
		For $i = 2 To $aFiles[0][0]
			$tString = $aFiles[$i][1]
			$iHours += StringLeft($tString, 2)
			$iMinutes += StringMid($tString, 4, 2)
			$iSeconds += StringRight($tString, 2)
		Next
		$tSeconds = $iHours*3600+$iMinutes*60+$iSeconds
		$iHours = Int($tSeconds/3600)
		$iMinutes = StringFormat("%02i", Int(Mod($tSeconds, 3600)/60))
		$iSeconds = StringFormat("%02i", Mod($tSeconds, 60))
		$aFiles[1][1] = $iHours & ":" & $iMinutes & ":" & $iSeconds
		If $iFolderLoaded = 1 Then
			$sText = "Folder (" & $sFolder
		Else
			$sText = "Files (" & $sFolder
		EndIf
		$sText &= $CDLabel
		$sText &= ") [" & $aFiles[1][1] & "]"
		_GUICtrlListView_SetColumn($ctrlView, 1, $sText)
		If $iFolderLoaded = 1 Then
			_PlaylistSave()
		EndIf
		GUICtrlSetColor($idTitle, 0)
		GUICtrlSetState($idFile, $GUI_ENABLE)
		GUICtrlSetState($idFolder, $GUI_ENABLE)
		If $sFilesToRepeat = "" Then
			GUICtrlSetState($idShuffle, $GUI_ENABLE)
			If $iFolderLoaded = 1 And Not StringInStr($aFiles[1][0], ":\") Then
				GUICtrlSetState($ctrlRescan, $GUI_ENABLE)
			EndIf
			If $iShuffled = 1 Then
				GUICtrlSetState($ctrlReshuffle, $GUI_ENABLE)
			EndIf
		EndIf
		Return
	ElseIf GUICtrlGetState($idShuffle) = 80 Then
		GUICtrlSetState($idShuffle, $GUI_DISABLE)
		GUICtrlSetState($idFile, $GUI_DISABLE)
		GUICtrlSetState($idFolder, $GUI_DISABLE)
		GUICtrlSetState($ctrlRescan, $GUI_DISABLE)
		GUICtrlSetState($ctrlReshuffle, $GUI_DISABLE)
	EndIf

	Local $sFile1 = $aFiles[$iList][0], $sPropertyValue
	If $iTrack = 0 Then
		If $iLenColNumber = 0 Then
			$iDoing = 0
			Return
		EndIf
		If Not StringInStr($sFile1, ":\") Then
			$sFile1 = $sFolder & $sFile1
		EndIf
		Local $sFileName, $sDir, $oDir, $oFile
		$sFileName = StringMid($sFile1, StringInStr($sFile1, "\", 0, -1)+1)
		$sDir = StringLeft($sFile1, StringInStr($sFile1, "\", 0, -1))
		$oDir = $oShellApp.NameSpace($sDir)
		$oFile = $oDir.Parsename($sFileName)
		If $iLenColNumber > 0 Then
			$sPropertyValue = $oDir.GetDetailsOf($oFile, $iLenColNumber)
		EndIf
	Else
		Local $track = _ArraySearch($aTracks, $sFile1)
		mciSendString("set myMedia time format tmsf")
		$sPropertyValue = mciSendString("status myMedia length track " & $track)
		If StringLeft($sPropertyValue, 2) > 59 Then
			$sPropertyValue = StringFormat("%02i:%02i:%92i", 1, StringLeft($sPropertyValue,2)-59, StringMid($sPropertyValue,4, 2))
		Else
			$sPropertyValue = "00:" & StringLeft($sPropertyValue, 5)
		EndIf
		mciSendString("set myMedia time format milliseconds")
	EndIf
	If StringInStr($sPropertyValue, ":") = 0 Then
		$sPropertyValue = "00:00:00"
	EndIf
	$aFiles[$iList][1] = $sPropertyValue
	$aItems[$iList-2][2] = $sPropertyValue
	GUICtrlSendMsg($ctrlView, $LVM_UPDATE, $iList-2, 0)
	$iDoing = 0
EndFunc		;==>_GetLength

Func _Help()	; Show/Hide Help window
	If $iFullScreen = 1 Then	; If video is in fullscreen mode, maximize it
		$iMaximized = 1
		_FullScreen()
	EndIf
	If $iHelp = 0 Then
		GUISetState(@SW_SHOW, $hHelp)
		$iHelp = 1
		ControlSend($hHelp, "", $helpEdit, "^{home}")
	Else
		GUISetState(@SW_HIDE, $hHelp)
		$iHelp = 0
	EndIf
EndFunc		;==>_Help

Func _IniSave()	; Save zPlayer.ini file in @ScrDirectory
	If $iFolderLoaded = 0 Or IsArray($aFiles) = 0 Or $aFiles[0][0] < 2 Then Return
	Local $sPlayer = "Folder=" & $sFolder & @LF
	$sPlayer &= "Volume Level=" & $iVolume & @LF
	$sPlayer &= "File Types=" & $sFileTypes & @LF
	$sPlayer &= "File Property Column Numbers=" & $sColNumbers & @LF
	Local $sResume = "Mode=" & $resumeMode & @LF
	$sResume &= "Minimum Total Length=" & $minTotalLength & @LF
	$sResume &= "Minimum Playback Length=" & $minPlaybackLength
	If Not FileExists($iniFile) Then
		Local $hFile = FileOpen($iniFile, 2+32)
		FileWriteLine($hFile, "[Player]")
		FileWrite($hFile, $sPlayer)
		FileWriteLine($hFile, "[Resume Playback]")
		FileWrite($hFile, $sResume)
		FileClose($hFile)
	Else
		IniWriteSection($iniFile, "Player", $sPlayer)
		IniWriteSection($iniFile, "Resume Playback", $sResume)
	EndIf
EndFunc		;==>_IniSave

Func _InternetSearch()	; Search current file in internet (Press Ctrl+Alt+i)
	If $iPlaying = 0 Then Return
	If Not _WinAPI_IsInternetConnected() Then
		MsgBox($MB_OK, "zPlayer", "Internet connection is not available!", 5)
		Return
	EndIf

	If $internetSearchFrom <> "" Then	; This If...Endif clause is executed only when hotkey has been pressed
		Local $tFile = $aFiles[$internetSearchFrom+2][0]
		If StringInStr($tFile, ":\") Then
			$sPath = $tFile
		Else
			$sPath = $sFolder & $tFile
		EndIf
	Else
		$sPath = $sFile
	EndIf

	Local $searchStr = StringMid($sPath, StringInStr($sPath, "\", 0, -1)+1)
	$searchStr = StringLeft($searchStr, StringInStr($searchStr, ".", 0, -1)-1)
	$searchStr = StringReplace(StringReplace(StringReplace(StringReplace(StringReplace($searchStr, "-", " "), "(", " "), ")", " "), "&", " "), "_", " ")
	$searchStr = StringStripWS($searchStr, 7)
	$searchStr = StringReplace($searchStr, " ", "+")
	Local $url = "https://duckduckgo.com/?q=" & $searchStr
	If WinExists(" at DuckDuckGo ") Then
		WinActivate(" at DuckDuckGo ")
		Sleep(100)
		Send("{F6}")
		ClipPut($url)
		Sleep(100)
		Send("^v")
		Sleep(100)
		Send("{enter}")
	Else
		ShellExecute($url, "", "", "", @SW_MAXIMIZE)
	EndIf
EndFunc		;==>_InternetSearch

Func _LoadFiles()	; Load files
	$iShuffled = 0
	$CDLabel = ""
	$iCD = 0
	Local $fileTypes = "*." & StringReplace($sFileTypes, " ", ";*.")
	While 1
		$sFiles = FileOpenDialog("LOAD ONE OR MORE MEDIA FILES", "", "Audio/Video (" & $fileTypes & ")", 7)
		If $sFiles = "" Then
			GUICtrlSetState($idFolder, $GUI_ENABLE)
			Return
		EndIf
		If Not StringInStr($sFiles, "|") Then
			Local $iPos = StringInStr($sFiles, "\", 0, -1)
			$sFiles = StringLeft($sFiles, $iPos) & "|" & StringMid($sFiles, $iPos+1)
		EndIf
		$aFiles = StringSplit($sFiles, "|")	; Folder name|File 1|File 2...
		$sFolder = $aFiles[1]
		If StringRight($sFolder, 1) <> "\" Then $sFolder &= "\"

		If DriveGetType($sFolder) = "CDROM" Then
			If Not StringInStr($sFiles, ".cda") Then
				$sMsg = "This CD does not have audio tracks." &  @CRLF
				$sMsg &= "This player does not support a data CD with music files."
				MsgBox($MB_OK, "No Audio CD", $sMsg)
				Return
			Else
				$aTracks = _FileListToArrayRec($sFolder, "*.cda", 1, 1, 0, 1)
				$sFile =  $sFolder & $aFiles[2]
				$aFiles[1] = $aFiles[2]
				$iTrack = _ArraySearch($aTracks, $sFile)
				_ArrayColInsert($aFiles, 1)
				$CDLabel = DriveGetLabel($sFolder)
				$iFolderLoaded = 0
				_PlaylistLoad()
				mciSendString("close myMedia")
				$iRet = mciSendString("open """ & $sFolder & """ alias myMedia type cdaudio wait")
			EndIf
		Else
			$sFile = $sFolder & $aFiles[2]
			$aFiles[1] = $aFiles[2]
			_ArrayColInsert($aFiles, 1)
			$iFolderLoaded = 0
			_PlaylistLoad()
			mciSendString("close myMedia")
			$iRet = mciSendString("open """ & $sFile & """ alias myMedia type MPEGVideo wait style popup parent " & $iGui)
		EndIf

		If $iRet = 1 Then
			ExitLoop
		Else
			$sMsg = $sFile & @CRLF & @CRLF
			$sMsg &= "This file cannot be opened by this player." & @CRLF
			$sMsg &= "Please check if proper codec is installed." & @CRLF & @CRLF
			MsgBox($MB_OK, "Open error", $sMsg)
			Return
		EndIf
	WEnd

	GUICtrlSetData($idFile, "Unload")
	GUICtrlSetData($idFolder, "Load Folder")
	GUICtrlSetPos($idFile, 155, 45, 61, 24)
	GUICtrlSetPos($idFolder, 216, 45, 79, 24)

	_Play()

EndFunc		;==>_LoadFiles

Func _LoadFolder()	; Load folder or CD
	If IsArray($aFiles) And $iFolderLoaded = 1 Then
		_PlaylistSave()
	EndIf
	If $iFullScreen = 1 Then	; If video is in fullscreen mode, maximize it
		$iMaximized = 1
		_FullScreen()
	EndIf

	Local $sFolder2, $aFiles2, $aFile, $iShuffled2
	Local $fileTypes = "*." & StringReplace($sFileTypes, " ", ";*.")
	GUICtrlSetState($idFile, $GUI_DISABLE)
	While 1
		; Load all files in a folder (and its subfolders)
		GUICtrlSetState($idFile, $GUI_DISABLE)
		$sFolder2 = FileSelectFolder("Select a folder with media files", $sFolder)
		If $sFolder2 = "" Then
			GUICtrlSetState($idFile, $GUI_ENABLE)
			Return
		EndIf
		If StringRight($sFolder2, 1) <> "\" Then $sFolder2 &= "\"
		If $sFolder2 = $sFolder And GUICtrlRead($idFolder) = "Change Folder" And $iFolderLoaded = 1 Then
			GUICtrlSetState($idFile, $GUI_ENABLE)
			If $iMute = 1 Then _Mute()
			Return
		EndIf

		Local $makePlaylist = 0
		If DriveGetType($sFolder2) <> "CDROM" Then
			$iCD = 0
			If FileExists($sFolder2 & "zPlaylist.txt") Then
				_FileReadToArray($sFolder2 & "zPlaylist.txt", $aFiles2, 1+4, ":|")
				If IsArray($aFiles2) = 0 Then
					_FileReadToArray($sFolder2 & "zPlaylist.txt", $aFiles2)
					_ArrayColInsert($aFiles2, 1)
				EndIf

				If $aFiles2[0][0] < 2 Then
					$makePlaylist = 1
				Else
					Local $bFolder, $itemsToDelete
					For $v = 2 To $aFiles2[0][0]
						If Not StringInStr($aFiles2[$v][0], ":\") Then
							$bFolder = $sFolder2
						Else
							$bFolder = ""
						EndIf
						If Not FileExists($bFolder & $aFiles2[$v][0]) Then
							$itemsToDelete &= $v & ";"
						EndIf
					Next

					If $itemsToDelete <> "" Then
						$itemsToDelete = StringTrimRight($itemsToDelete, 1)
						_ArrayDelete($aFiles2, $itemsToDelete)
						$aFiles2[0][0] = UBound($aFiles2)-1
						FileDelete($sFolder2 & "zPlaylist.txt")
						FileDelete($sFolder2 & "zPlaylist-Shuffled.txt")
					EndIf
					If $aFiles2[0][0] < 2 Then
						$makePlaylist = 1
					Else
						$aFile = StringSplit($aFiles2[1][0], "||", 1)
						If $aFile[0] > 1 And $aFile[2] = "Shuffled" Then
							$iShuffled2 = 1
							If FileExists($sFolder2 & "zPlaylist-Shuffled.txt") Then
								_FileReadToArray($sFolder2 & "zPlaylist-Shuffled.txt", $aFiles2, 1+4, ":|")
								If IsArray($aFiles2) = 0 Then
									_FileReadToArray($sFolder & "zPlaylist-Shuffled.txt", $aFiles2)
									_ArrayColInsert($aFiles2, 1)
								EndIf
							Else
								_ArrayShuffle($aFiles2, 2)
							EndIf
						Else
							$iShuffled2 = 0
						EndIf
						If $aFile[0] = 3 Then
							$resumePosition = ($aFile[3]-10)*1000	; Resume playback at 10 seconds before last playback position
						EndIf
					EndIf
				EndIf
			Else
				$makePlaylist = 1
			EndIf

			If $makePlaylist = 1 Then
				FileDelete($sFolder2 & "zPlaylist.txt")
				FileDelete($sFolder2 & "zPlaylist-Shuffled.txt")
				$aFiles2 = _FileListToArrayRec($sFolder2, $fileTypes, 1, 1, 1, 1) ; include files in subfolders
				If Not (IsArray($aFiles2) And $aFiles2[0] > 0) Then
					Local $iRes = MsgBox($MB_RETRYCANCEL, "Select Folder", "This folder does not contain any media file." & @CRLF & "Try once again?")
					If $iRes = $IDRETRY Then
						ContinueLoop
					Else
						Return
					EndIf
				EndIf

				; If the selected folder has media files in both top-level and sub-level folders, you have an option to include or exclude files in subfolders
				Local $iRootFolders, $iSubFolders, $iRet
				For $i = 1 To $aFiles2[0]
					If StringInStr($aFiles2[$i], "\") Then
						$iSubFolders += 1
					Else
						$iRootFolders += 1
					EndIf
				Next
				If $iSubFolders > 0 And $iRootFolders > 0 Then
					Local $sMsg = "Number of files in top-level folder:" & @TAB & $iRootFolders & @CRLF
					$sMsg &= "Number of files in sub-level folders:" & @TAB & $iSubFolders & @CRLF & @CRLF
					$sMsg &= "Do you want to include files in the subfolders?"
					$iRet = MsgBox($MB_YESNO, "Include files in subfolders?", $sMsg)
					If $iRet = $IDNO Then
						$aFiles2 = _FileListToArrayRec($sFolder2, $fileTypes, 1, 0, 1, 1) ; exclude files in subfolders
					EndIf
				EndIf

				_ArrayInsert($aFiles2, 1, $aFiles2[1])
				_ArrayColInsert($aFiles2, 1)
				$aFiles2[0][0] += 1
				$aFiles2[1][0] = $aFiles2[2][0]
				$iShuffled2 = 0
			EndIf

			_Unload_1()	; Partially initialize playback environment
			$sFolder = $sFolder2
			$aFiles = $aFiles2
			$iShuffled = $iShuffled2
			$iFolderLoaded = 1
			_PlaylistLoad()

			$iRet = mciSendString("open """ & $sFile & """ alias myMedia type MPEGVideo wait style popup parent " & $iGui)
		Else	; Play whole CD
			$iCD = 1
			$CDLabel = DriveGetLabel($sFolder)
			Local $aTracks2 = _FileListToArrayRec($sFolder2, "*.cda", 1, 1, 0, 1)

			If Not IsArray($aTracks2) Then
				$sMsg = "This CD does not have audio tracks." &  @CRLF
				$sMsg &= "This player does not support a data CD with music files."
				MsgBox($MB_OK, "No Audio CD", $sMsg)
				Return
			EndIf

			_Unload_1()

			$makePlaylist = 1
			$iTrack = _CDCheck($sFolder2, $aTracks2, $aFiles2)
			If $iTrack > 0 Then
				Local $sMode, $aMode, $sList
				$sMode = IniRead($iniFile, "Audio CD", "Play Mode", "")
				$sList = IniRead($iniFile, "Audio CD", "Playlist", "")
				If $sList <> "" Then
					$aFiles2 = StringSplit($sList, "|")
				EndIf
				$iShuffled = 0
				If $sMode <> "" Then
					$aMode = StringSplit($sMode, "|")
					If $aMode[1] = "Shuffled" Then
						$iShuffled = 1
					EndIf
				EndIf
				If IsArray($aFiles2) Then
					If $iShuffled = 0 Then
						$aFiles2 = _ArraySort($aFiles2, 1)
					EndIf
					If $aMode[0] = 2 Then $resumePosition = ($aMode[2]-10)*1000
					$aFiles = $aFiles2
					$aTracks = $aTracks2
					_ArrayInsert($aFiles, 1, $aTracks[$iTrack])
					$aFiles[0] += 1
					_ArrayColInsert($aFiles, 1)
					$sFile = $aTracks[$iTrack]
					$makePlaylist = 0
					$sFolder = $sFolder2
					$iFolderLoaded = 1
					_PlaylistLoad()
				EndIf
			EndIf

			If $makePlaylist = 1 Then
				_Unload_1()
				$aTracks = $aTracks2
				$aFiles = $aTracks
				$iTrack = 1
				$sFile = $aTracks[$iTrack]
				_ArrayInsert($aFiles, 1, $sFile)
				$aFiles[0] += 1
				_ArrayColInsert($aFiles, 1)
				$iShuffled = 0
				$sFolder = $sFolder2
				$iFolderLoaded = 1
				_PlaylistLoad()
				_PlaylistSave()
			EndIf
			$iRet = mciSendString("open """ & $sFolder & """ alias myMedia type cdaudio wait")
		EndIf
		GUICtrlSetState($idPrefSave, $GUI_ENABLE)

		If $iRet = 1 Then
			ExitLoop
		Else
			$sMsg = $sFile & @CRLF & @CRLF
			$sMsg &= "This file cannot be loaded by this player." & @CRLF
			$sMsg &= "Please check if proper codec is installed."
			MsgBox($MB_OK, "Open error", $sMsg)
			Return
		EndIf
	WEnd

	If $iMute = 1 Then _Mute()

	GUICtrlSetData($idFile, "Unload")
	GUICtrlSetData($idFolder, "Change Folder")
	GUICtrlSetPos($idFile, 155, 45, 48, 24)
	GUICtrlSetPos($idFolder, 203, 45, 92, 24)

	_Play()

EndFunc		;==>_LoadFolder

Func _LoadLastFolder()	; Load the playlist which was saved when the program was terminated last time
	If Not FileExists($iniFile) Then Return
	$CDLabel = ""
	If DriveGetType($sFolder) = "CDROM" Then
		$iCD = 1
		Local $sMode, $aMode, $sList, $aTracks2, $aFiles2, $return = 1
		$aTracks2 = _FileListToArrayRec($sFolder, "*.cda", 1, 1, 1, 1)
		If IsArray($aTracks2) Then
			$iTrack = _CDCheck($sFolder, $aTracks2, $aTracks2)
			If $iTrack > 0 Then
				$sMode = IniRead($iniFile, "Audio CD", "Play Mode", "")
				$sList = IniRead($iniFile, "Audio CD", "Playlist", "")
				If $sList <> "" Then
					$aFiles2 = StringSplit($sList, "|")
				EndIf
				$iShuffled = 0
				If $sMode <> "" Then
					$aMode = StringSplit($sMode, "|")
					If $aMode[1] = "Shuffled" Then
						$iShuffled = 1
					EndIf
				EndIf
				If IsArray($aFiles2) Then
					If $iShuffled = 0 Then
						_ArraySort($aFiles2, 0, 1)
					EndIf
					If $aMode[0] = 2 Then $resumePosition = ($aMode[2]-10)*1000
					$aFiles = $aFiles2
					$aTracks = $aTracks2
					_ArrayInsert($aFiles, 1, $aTracks[$iTrack])
					$aFiles[0] += 1
					_ArrayColInsert($aFiles, 1)
					$sFile = $aTracks[$iTrack]
					If mciSendString("open """ & $sFolder & """ alias myMedia type cdaudio wait") = 1 Then
						$return = 0
						$iFolderLoaded = 1
						_PlaylistLoad()
					EndIf
				EndIf
			EndIf
		EndIf
		If $return = 1 Then Return
	Else
		$iCD = 0
		If Not FileExists($sFolder & "zPlaylist.txt") Then
			Return
		EndIf
		_FileReadToArray($sFolder & "zPlaylist.txt", $aFiles, 1+4, ":|")
		If IsArray($aFiles) = 0 Then
			_FileReadToArray($sFolder & "zPlaylist.txt", $aFiles)
			If $aFiles[0] < 2 Then Return
			_ArrayColInsert($aFiles, 1)
		ElseIf $aFiles[0][0] < 2 Then
			Return
		EndIf

		Local $bFolder, $itemsToDelete
		For $v = 2 To $aFiles[0][0]
			If Not StringInStr($aFiles[$v][0], ":\") Then
				$bFolder = $sFolder
			Else
				$bFolder = ""
			EndIf
			If Not FileExists($bFolder & $aFiles[$v][0]) Then
				$itemsToDelete &= $v & ";"
			EndIf
		Next

		If $itemsToDelete <> "" Then
			$itemsToDelete = StringTrimRight($itemsToDelete, 1)
			_ArrayDelete($aFiles, $itemsToDelete)
			$aFiles[0][0] = UBound($aFiles)-1
			FileDelete($sFolder & "zPlaylist.txt")
			FileDelete($sFolder & "zPlaylist-Shuffled.txt")
		EndIf
		If $aFiles[0][0] < 2 Then
			FileDelete($sFolder & "zPlaylist.txt")
			FileDelete($sFolder & "zPlaylist-Shuffled.txt")
			Return
		EndIf

		Local $aFile = StringSplit($aFiles[1][0], "||", 1)
		$iIndex = _ArraySearch($aFiles, $aFile[1], 2)
		If $iIndex = 0 Then Return

		$iFolderLoaded = 1
		If $aFile[0] > 1 And $aFile[2] = "Shuffled" Then
			$iShuffled = 1
		Else
			$iShuffled = 0
		EndIf
		_PlaylistLoad()

		$iRet = mciSendString("open """ & $sFile & """ alias myMedia type MPEGVideo wait style popup parent " & $iGui)
		If $iRet <> 1 Then
			$sMsg = $sFile & @CRLF & @CRLF
			$sMsg &= "This file cannot be opened by this player." & @CRLF
			$sMsg &= "Please check if proper codec is installed." & @CRLF & @CRLF
			MsgBox($MB_OK, "Open error", $sMsg)
			Return
		EndIf

		If $aFile[0] = 3 Then
			$resumePosition = ($aFile[3]-10)*1000	; Resume playback at 10 seconds before last playback position
		EndIf
	EndIf

	GUICtrlSetData($idFile, "Unload")
	If $iFolderLoaded = 1 Then
		GUICtrlSetData($idFolder, "Change Folder")
		GUICtrlSetPos($idFile, 155, 45, 48, 24)
		GUICtrlSetPos($idFolder, 203, 45, 92, 24)
	Else
		GUICtrlSetData($idFolder, "Load Folder")
		GUICtrlSetPos($idFile, 155, 45, 61, 24)
		GUICtrlSetPos($idFolder, 216, 45, 79, 24)
	EndIf

	_Play()

EndFunc		;==>_LoadLastFolder

Func _LoadVerify($folder, $array)	; Verify if files exist before loading them to playlist
	Local $bFolder, $itemsToDelete
	For $v = 2 To $array[0][0]
		If Not StringInStr($array[$v][0], ":\") Then
			$bFolder = $folder
		Else
			$bFolder = ""
		EndIf
		If Not FileExists($bFolder & $array[$v][0]) Then
			$itemsToDelete &= $v & ";"
		EndIf
	Next

	If $itemsToDelete <> "" Then
		$itemsToDelete = StringTrimRight($itemsToDelete, 1)
		_ArrayDelete($array, $itemsToDelete)
		$array[0][0] = UBound($array)-1
	EndIf
	Return $array
EndFunc		;==>_LoadVerify

Func _Marquee()	; Adlib function to make file name flow in marquee style if its length is longer than the control width
	$iMarquee += 1
	If $iMarquee <= 10 Then Return	; stops for 5 seconds when marquee starts anew
	$sStr = StringMid($sTitle, $iMarquee-10, $iCharacters)
	$iLen = StringLen($sStr)
	If $iLen >= $iCharacters Then
		GUICtrlSetData($idTitle, $sStr)
	ElseIf $iLen > 0 Then
		GUICtrlSetData($idTitle, $sStr & $sTitle)
	Else
		GUICtrlSetData($idTitle, $sTitle)
		$iMarquee = 0
	EndIf
EndFunc		;==>_Marquee

Func _MaximizeScreen()	; Maximize $hVideo, called by _Play() and $GUI_EVENT_MAXIMIZE of $hVideoGUI
 	$x = -$borderWidth
	$y = 0
	$w = @DesktopWidth+$borderWidth*2
	$h = $scrHeight+$borderWidth
	WinMove($hVideoGUI, "", $x, $y, $w, $h)
	$videoWidth = @DesktopWidth
	$videoHeight = Int($videoWidth/$imgRatio)
	If $videoHeight > $scrHeight-$iMaximizedTitleHeight Then
		$videoHeight = $scrHeight-$iMaximizedTitleHeight
		$videoWidth = Int($videoHeight*$imgRatio)
	EndIf
	$w = $videoWidth
	$h = $videoHeight
	$x = (@DesktopWidth-$videoWidth)/2
	$y = $iMaximizedTitleHeight+($scrHeight-$iMaximizedTitleHeight-$videoHeight)/2
	WinMove($hVideo, "", $x, $y, $w, $h)
EndFunc		;==>_MaximizeScreen

Func _Mute()	; Mute on/off
	If $iMute = 0 Then
		$muteState = _Audio_Action("SetMute", $gPID, True)	; Returns True if muted, False if unmuted
		GUICtrlSetData($idSpeaker, "🔇")
		GUICtrlSetData($idSpeaker2, "🔇")
		$iMute = 1
	Else
		$muteState = _Audio_Action("SetMute", $gPID, False)	; Returns True if muted, False if unmuted
		GUICtrlSetData($idSpeaker, "🔊")
		GUICtrlSetData($idSpeaker2, "🔊")
		$iMute = 0
		; If folder is changed, the new audio device(myMedia) resumes default unmuted state
	EndIf
EndFunc		;==>_Mute

Func _Pause()	; Play or pause the playback (Click ▶/𝅛𝅛 icon on graphical control or press Ctrl+Alt+p)
	If $iPlaying = 0 Then Return
	Local Static $pausedPos
	If $iPaused = 1 Then
		AdlibRegister("_ProgressBar", 250)
		If $iTitleWidth > $guiWidth Then
			AdlibRegister("_Marquee", 500)
		EndIf
		If $iTrack = 0 Then
			mciSendString("resume myMedia")
		Else
			mciSendString("seek myMedia to " & $pausedPos)
			mciSendString("play myMedia")
		EndIf
		$iPaused = 0
		$iPlaying = 1
		GUICtrlSetData($idPlay, "❚❚")
		GUICtrlSetFont($idPlay, 18)
		GUICtrlSetPos($idPlay, 58, 45, 16, 18)
		GUICtrlSetData($idPlay2, "❚❚")
		GUICtrlSetFont($idPlay2, 18)
		GUICtrlSetPos($idPlay2, $vcWidth/2-58, 16, 16, 18)
		_WinAPI_SetThreadExecutionState(BitOR($ES_DISPLAY_REQUIRED, $ES_CONTINUOUS, $ES_SYSTEM_REQUIRED, $ES_AWAYMODE_REQUIRED))
		; Disable ScreenSaver and other windows sleep features
	Else
		AdlibUnRegister("_ProgressBar")
		AdlibUnRegister("_Marquee")
		If $iTrack = 0 Then
			mciSendString("pause myMedia")
		Else
			$pausedPos = mciSendString("status myMedia position")
			mciSendString("stop myMedia")
		EndIf
		$iPaused = 1
		$iPlaying = 1
		GUICtrlSetData($idPlay, "▶")
		GUICtrlSetFont($idPlay, 10)
		GUICtrlSetPos($idPlay, 60, 51, 16, 15)
		GUICtrlSetData($idPlay2, "▶")
		GUICtrlSetFont($idPlay2, 10)
		GUICtrlSetPos($idPlay2, $vcWidth/2-56, 22, 16, 18)
		_WinAPI_SetThreadExecutionState($ES_CONTINUOUS)	; Back to normal windows behavior
	EndIf
EndFunc		;==>_Pause

Func _Play()	; Play a new file
	$sTitle = StringMid($sFile, StringInStr($sFile, "\", 0, -1)+1)
	$currentFile = $aFiles[$iIndex][0]
	AdlibUnRegister("_Marquee")
	GUICtrlSetData($idTitle, $sTitle)
	$iPaused = 0
	$iPlaying = 1
	GUICtrlSetData($idPlay, "❚❚")
	GUICtrlSetFont($idPlay, 18)
	GUICtrlSetPos($idPlay, 58, 45, 16, 18)
	GUICtrlSetState($idTitle, $GUI_ENABLE)
	GUICtrlSetState($idSlider, $GUI_ENABLE)
	If $sFilesToRepeat = "" Then
		GUICtrlSetState($idShuffle, $GUI_ENABLE)
	EndIf
	GUICtrlSetState($idPlay, $GUI_ENABLE)
	GUICtrlSetState($idPrevious, $GUI_ENABLE)
	GUICtrlSetState($idRepeat, $GUI_ENABLE)
	GUICtrlSetState($idNext, $GUI_ENABLE)
	GUICtrlSetState($idSpeaker, $GUI_ENABLE)

	; The Length column of playlist is initially filled by _GetLength() function using shell.application method.
	; The following snippet will dynamically update the playlist using winmm.dll command string at the time the file is playing.
	Local $iHours, $iMinutes, $iSeconds, $tSeconds, $tString, $sString
	mciSendString("set myMedia time format milliseconds")
	If StringRight($aFiles[$iIndex][0], 4) = ".cda" Then
		$iTrack = _ArraySearch($aTracks, $aFiles[$iIndex][0])
		$iLength = mciSendString("status myMedia length track " & $iTrack)
		$iTrackPos = mciSendString("status myMedia position track " & $iTrack)
	Else
		$iLength = mciSendString("status myMedia length")   ; milliseconds
		$iTrack = 0
	EndIf
	$tSeconds = Int($iLength/1000)
	$iMinutes = Int($tSeconds/60)
	$iSeconds = StringFormat("%02i", $tSeconds-$iMinutes*60)
	GUICtrlSetData($idLength, $iMinutes & ":" & $iSeconds)
	$iHours = Int($iMinutes/60)
	$iMinutes = $iMinutes-$iHours*60
	If $iHours > 0 Then	; $tString for $idLength2
		$tString = $iHours & ":" & StringFormat("%02i", $iMinutes) & ":" & $iSeconds
	Else
		$tString = $iMinutes & ":" & $iSeconds
	EndIf
	$sString = StringFormat("%02i", $iHours) & ":" & StringFormat("%02i", $iMinutes) & ":" & $iSeconds
	If $aFiles[$iIndex][1] <> $sString Then
		$aFiles[$iIndex][1] = $sString
		$aItems[$iIndex-2][2] = $sString
		GUICtrlSendMsg($ctrlView, $LVM_UPDATE, $iList-2, 0)
		If $iAllDone = 1 Then
			$iAllDone = 0
			GUICtrlSetColor($idTitle, 0xFF0055)
			AdlibRegister("_GetLength", 25)
		EndIf
	EndIf

	_PlaylistHighlight()

	Local $sSource, $aSource, $tmpGUI, $tmpLabel
	$sSource = mciSendString("where myMedia source")    ; "left top width height"
	If $sSource <> "" Then
		If $iMaximizedTitleHeight = 0 Then
			Local $tmp = GUICreate("", @DesktopWidth, @DesktopHeight, 0, 0)	; obtain title height of a maximized window
			GUISetState(@SW_MAXIMIZE, $tmp)
			Local $aPos = WinGetClientSize($tmp)
			GUIDelete($tmp)
			$iMaximizedTitleHeight = @DesktopHeight-$aPos[1]	; 23
		EndIf
		$aSource = StringSplit($sSource, " ")
		$iVideo = 1
		$imgWidth = $aSource[3]
		$imgHeight = $aSource[4]
		$imgRatio = Round($imgWidth/$imgHeight, 5)
		$hVideo = WinGetHandle($sFile)
		WinMove($hVideo, "", (@DesktopWidth-$imgWidth)/2, (@DesktopHeight-$imgHeight)/2)
	Else
		GUISetState(@SW_HIDE, $hVideoGUI)
		$iVideo = 0
		AdlibUnRegister("_VCShow")
		AdlibUnRegister("_VCResize")
	EndIf

	If $resumePosition < $minPlaybackLength Or Int($iLength/1000) < $minTotalLength Or $resumeMode = "Never" Then
		$resumePosition = 0	; $resumePosition defined in _LoadFolder() function
	ElseIf $resumeMode = "Ask" Then
		$iRet = MsgBox($MB_YESNO, "Resume Playback", "Do you want to resume playback from the last playback position?")
		If $iRet = $IDNO Then
			$resumePosition = 0
		EndIf
	EndIf

	Local $playPos
	If $resumePosition = 0 Then
		If $iTrack > 0 Then
			$playPos = $iTrackPos
		Else
			$playPos = 50
		EndIf
	Else
		If $iTrack > 0 Then
			$playPos = $iTrackPos+$resumePosition
		Else
			$playPos = $resumePosition
		EndIf
	EndIf

	mciSendString("play myMedia from " & $playPos)

	If $resumePosition > 0 Then
		DllCall($hDLL, "int", "waveOutSetVolume", "int", 0 , "int", 6553)
		$volumeStep = $iVolume/10
		AdlibUnRegister("_VolumeSync")
		AdlibRegister("_FadeIn", 400)
	Else
		AdlibRegister("_VolumeSync")
	EndIf
	$resumePosition = 0
	If $iCD =1 Then
		$iCDLength = mciSendString("status myMedia length")
	EndIf

	If $iVideo = 1 Then		; This If...Endif clause should be declared only after video is put to play
		If $iFullScreen = 1 Then
			$iFullScreen = 0
			_FullScreen()
		ElseIf $iMaximized = 1 Then
			_MaximizeScreen()
		Else
			_VideoResize(Int(@DesktopWidth/3*2))
		EndIf
		_VCCreate($tString)		; Create video control($vcGUI)
		_VCResize()
		WinSetTitle($hVideoGUI, "", "zPlayer Video: " & $sTitle)
		GUISetState(@SW_SHOW, $hVideoGUI)
		WinSetState($hVideo, "", @SW_SHOW)
		GUISetState(@SW_SHOW, $vcGUI)
		AdlibRegister("_VCShow", 250)
		AdlibRegister("_VCResize", 500)
	EndIf
	AdlibRegister("_ProgressBar", 250)

	WinSetTitle($hMain, "", $guiTitle & @CRLF & $sTitle)
	; This enables zPlayer tooltip in Windows taskbar to show current file name
	; All other GUIs must be created as children of $hMain to make this effective

	$tmpGUI = GUICreate("")		; Temporary GUI to measure pixel width of $sTitle
	$tmpLabel = GUICtrlCreateLabel($sTitle, 0, 0)
	$iTitleWidth = ControlGetPos($tmpGUI, "", $tmpLabel)[2]
	$iCharacters = Int($guiWidth/$characterWidth)
	GUIDelete($tmpGUI)

	If $iTitleWidth > $guiWidth Then
		$sTitle &= "          "
		$iMarquee = 0
		AdlibRegister("_Marquee", 500)
	EndIf

	$sPath = $sFile
	_FilePropertiesGet()
	$currentFileProperties = $aFileInfo
	If $iProperties = 1 Then
		_GUICtrlListView_DeleteAllItems($idPropertiesView)
		_GUICtrlListView_AddArray($idPropertiesView, $currentFileProperties)
		WinActivate($hProperties)
	EndIf

	$aFiles[1][0] = $currentFile

	_WinAPI_SetThreadExecutionState(BitOR($ES_DISPLAY_REQUIRED, $ES_CONTINUOUS, $ES_SYSTEM_REQUIRED, $ES_AWAYMODE_REQUIRED))
	; Disable ScreenSaver and other windows sleep features
EndFunc		;==>_Play

Func _PlayNext()	; Play next file (Click right side of ◀U▶ icon on graphical control or press atrl+alt+right arrow)
	If $iPlaying = 0 Then Return
	$iRepeat = 1
	_Repeat()
	GUICtrlSetData($idPlay, "❚❚")
	GUICtrlSetFont($idPlay, 18)
	GUICtrlSetPos($idPlay, 58, 45, 16, 18)
	mciSendString("stop myMedia")
	If $iMute = 1 Then _Mute()
EndFunc		;==>_PlayNext

Func _PlayPrevious()	; Play previous file (Click left side of ◀U▶ icon on graphical control or press Ctrl+Alt+left arrow)
	If $iPlaying = 0 Then Return
	$iRepeat = 1
	_Repeat()
	GUICtrlSetData($idPlay, "❚❚")
	GUICtrlSetFont($idPlay, 18)
	GUICtrlSetPos($idPlay, 58, 45, 16, 18)
	$iIndex -= 2
	If $aFilesToRepeat[0] > 0 Then	; Skip non-repeat files and move to the nearest previous repeat file
		While $iIndex > 1 And Not StringInStr($sFilesToRepeat, "," & $iIndex & ",")
			$iIndex -= 1
		WEnd
	EndIf
	mciSendString("stop myMedia")
	If $iMute = 1 Then _Mute()
EndFunc		;==>_PlayPrevious

Func _PlaylistCreate()	; Create playlist window
	$hPlaylist = GUICreate("Playing in Sorted Order...", $listWidth, $listHeight, -1, 0, $WS_OVERLAPPEDWINDOW, -1, $hMain)
	GUISetIcon(@ScriptDir & "\zPlayer.ico")
	GUISetFont(9, 400, "", "Arial", $hPlaylist)
	$ctrlView = GUICtrlCreateListView("No|Folder|Length", 0, 0, $listWidth, $viewHeight, $iStyles, $iStylesEx)
	GUICtrlSetResizing(-1, $GUI_DOCKBORDERS)
	GUICtrlSetPos($ctrlView, 0, 0, $listWidth+2, $viewHeight)					; +2 eliminates right-side black borderline
	_GUICtrlListView_SetColumnWidth($ctrlView, 0, $col1Width)
	_GUICtrlListView_SetColumnWidth($ctrlView, 1, $listWidth-$col1Width-60-21)	; -21 eliminates horizontal scroll bar
	_GUICtrlListView_SetColumnWidth($ctrlView, 2, 60)
	_GUICtrlListView_SetColumn($ctrlView, 0, "No", -1, 2)		; center align
	_GUICtrlListView_SetColumn($ctrlView, 2, "Length", -1, 2)	; center align

	Local $center = $listWidth/2
	$ctrlSearchBox = GUICtrlCreateInput("", $center-220, $viewHeight+4, 120, 18)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetTip(-1, 'Enter search strings. Use quotation' & @CRLF & "marks for exact-match.", "", 1, 1)
	$ctrlFind = GUICtrlCreateButton("Find First", $center-100, $viewHeight+3, 65, 20, $BS_BOTTOM)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetTip(-1, "Find first file containing these strings", "", 1, 1)
	$ctrlNext = GUICtrlCreateButton("Find Next", $center-35, $viewHeight+3, 65, 20, $BS_BOTTOM)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetTip(-1, "Find next file containing these strings", "", 1, 1)
	$ctrlRevert = GUICtrlCreateButton("Revert", $center+30, $viewHeight+3, 50, 20, $BS_BOTTOM)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetTip(-1, "Go back to currrent file", "", 1, 1)
	$ctrlRescan = GUICtrlCreateButton("Rescan", $center+95, $viewHeight+3, 60, 20, $BS_BOTTOM)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetTip(-1, "Rescan the current folder", "", 1, 1)
	$ctrlReshuffle = GUICtrlCreateButton("Reshuffle", $center+155, $viewHeight+3, 65, 20, $BS_BOTTOM)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetTip(-1, "Reshuffle the current playlist", "", 1, 1)
	$idPrefLabel1 = GUICtrlCreateLabel("Select option for resuming playback from the last playback position:", $center-220, $viewHeight+25, 380, 15)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefRadio1 = GUICtrlCreateRadio("Never", $center-220, $viewHeight+40, 60, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefRadio2 = GUICtrlCreateRadio("Ask", $center-152, $viewHeight+40, 40, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefRadio3 = GUICtrlCreateRadio("Always", $center-100, $viewHeight+40, 60, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefLabel2 = GUICtrlCreateLabel("*Subject to following conditions", $center-30, $viewHeight+42, 190, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefLabel3 = GUICtrlCreateLabel("Minimum Total Length:", $center-220, $viewHeight+60, 130, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefTotal = GUICtrlCreateInput($minTotalLength, $center-93, $viewHeight+58, 36, 20, $ES_NUMBER+$ES_RIGHT)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefLabel4 = GUICtrlCreateLabel("Minimum Playback Length:", $center-45, $viewHeight+60, 155, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefPlayed = GUICtrlCreateInput($minPlaybackLength, $center+105, $viewHeight+58, 36, 20, $ES_NUMBER+$ES_RIGHT)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefLabel5 = GUICtrlCreateLabel("(in seconds)", $center+148, $viewHeight+60, 75, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrefSave = GUICtrlCreateButton("Save", $center+170, $viewHeight+28, 50, 30)	; Just to take focus off from other selections
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	Switch $resumeMode
		Case "Never"
			GUICtrlSetState($idPrefRadio1, $GUI_CHECKED)
		Case "Ask"
			GUICtrlSetState($idPrefRadio2, $GUI_CHECKED)
		Case "Always"
			GUICtrlSetState($idPrefRadio3, $GUI_CHECKED)
	EndSwitch
	GUICtrlSetData($idPrefTotal, $minTotalLength)
	GUICtrlSetData($idPrefPlayed, $minPlaybackLength)
	$aPos = WinGetPos($hPlaylist)
	WinMove($hPlaylist, "", (@DesktopWidth-$aPos[2])/2, 0)
EndFunc		;==>_PlaylistCreate

Func _PlaylistHighlight()	; Highlight the current file in the playlist window
	_GUICtrlListView_SetItemSelected($ctrlView, $iIndex-2, True, True)
	_GUICtrlListView_Scroll($ctrlView, 0, $aFiles[0][0]*-$itemHeight)
	_GUICtrlListView_Scroll($ctrlView, 0, ($iIndex-(ControlGetPos($hPlaylist, "", $ctrlView)[3])/$itemHeight/2)*$itemHeight)
	GUICtrlSetState($ctrlView, $GUI_FOCUS)
EndFunc		;==>_PlaylistHighlight

Func _PlaylistLoad()
	Local $winLoading = GUICreate("Playlist", $listMinimumWidth-20, 45, -1, 150, $WS_POPUPWINDOW, $WS_EX_TOPMOST)
	GUISetFont(9, 600, 0, "Arial Bold", $winLoading)
	GUICtrlCreateLabel("Loading playlist...", 0, 15, $listMinimumWidth-20, 20, $SS_CENTER)
	GUISetState()

	Local $sList, $aFiles2, $aFile, $sText, $shuffled, $sorted, $hFile
	If $iTrack = 0 Then
		If $iShuffled = 1 Then
			If $iFolderLoaded = 0 Then
				_ArrayShuffle($aFiles, 2)
			Else
				$sList = $sFolder & "zPlaylist-Shuffled.txt"
				If FileExists($sList) Then
					_FileReadToArray($sList, $aFiles2, 1+4, ":|")
					If IsArray($aFiles2) = 1 Then ;And $aFiles2[0][0] = $aFiles[0][0] Then
						$aFiles2[1][0] = $aFiles[1][0]
						$aFiles = $aFiles2
					Else
						_ArrayShuffle($aFiles, 2)
						$shuffled = 1
					EndIf
				Else
					_ArrayShuffle($aFiles, 2)
					$shuffled = 1
				EndIf
			EndIf
		Else
			If $iFolderLoaded = 0 Then
				_ArraySort($aFiles, 0, 2)
			Else
				$sList = $sFolder & "zPlaylist.txt"
				If FileExists($sList) Then
					_FileReadToArray($sList, $aFiles2, 1+4, ":|")
					If IsArray($aFiles2) = 1 Then ;And $aFiles2[0][0] = $aFiles[0][0] Then
						$aFiles2[1][0] = $aFiles[1][0]
						$aFiles = $aFiles2
					Else
						_ArraySort($aFiles, 0, 2)
						$sorted = 1
					EndIf
				Else
					_ArraySort($aFiles, 0, 2)
					$sorted = 1
				EndIf
			EndIf
		EndIf
		If $shuffled = 1 Then
			$hFile = FileOpen($sFolder & "zPlaylist-Shuffled.txt", 2+32)
			_FileWriteFromArray($hFile, $aFiles, 1, Default, ":|")
		ElseIf $sorted = 1 Then
			$hFile = FileOpen($sFolder & "zPlaylist.txt", 2+32)
			_FileWriteFromArray($hFile, $aFiles, 1, Default, ":|")
		EndIf
	EndIf

	$aFile = StringSplit($aFiles[1][0], "||", 1)
	$iIndex = _ArraySearch($aFiles, $aFile[1], 2)
	If $iIndex = -1 Then
		$iIndex = 2
		$aFiles[1][0] = $aFiles[$iIndex][0]
	EndIf
	$sFile = $aFiles[$iIndex][0]
	If Not StringInStr($sFile, ":\") Then
		$sFile = $sFolder & $sFile
	EndIf

	If $aFiles[0][0]-1 < 1000 Then
		$col1Width = 29
	ElseIf $aFiles[0][0]-1 < 10000 Then
		$col1Width = 38
	Else
		$col1Width = 47
	EndIf

	Local $lenArray[$aFiles[0][0]-1]
	For $v = 2 To $aFiles[0][0]
		If $aFiles[$v][0] = "" Or StringLeft($aFiles[$v][0], 1) = " " Then ContinueLoop
		$lenArray[$v-2] = StringLen($aFiles[$v][0])
	Next
	_ArraySort($lenArray)
	; this array contains string lengths of playlist items
	Local $titleLen = $lenArray[Int(($aFiles[0][0]-2)*0.8+0.5)]	; column will be wide enough to show full length of 80 percentile of items
	$listWidth = $titleLen*$characterWidth+$col1Width+60		; 60 is the width of Length column
	If $listWidth < $listMinimumWidth Then $listWidth = $listMinimumWidth
	If $listWidth > @DesktopWidth Then $listWidth = @DesktopWidth
	GUIDelete($hPlaylist)
	$hPlaylist = ""
	_PlaylistCreate()

	If $iShuffled = 1 Then
		WinSetTitle($hPlaylist, "", "Playing in Shuffled Order...")
		GUICtrlSetData($idShuffle, "Sort")
		GUICtrlSetState($ctrlReshuffle, $GUI_ENABLE)
	Else
		WinSetTitle($hPlaylist, "", "Playing in Sorted Order...")
		GUICtrlSetData($idShuffle, "Shuffle")
		GUICtrlSetState($ctrlReshuffle, $GUI_DISABLE)
	EndIf

	GUICtrlSetState($idShuffle, $GUI_DISABLE)
	GUICtrlSetState($idFile, $GUI_DISABLE)
	GUICtrlSetState($idFolder, $GUI_DISABLE)
	GUICtrlSetState($ctrlRescan, $GUI_DISABLE)
	GUICtrlSetState($ctrlReshuffle, $GUI_DISABLE)

	$aItems = $aFiles
	_ArrayDelete($aItems, "0-1")
	_ArrayColInsert($aItems, 0)

	Local $iRows = UBound($aItems)
	ReDim $aColors[$iRows][3]
	For $i = 0 To $iRows-1
		$aItems[$i][0] = $i+1
		For $j = 0 To 2
			$aColors[$i][$j] = "0xFFFFFF"	; Background color for all items will be white
		Next
	Next

	If $iFolderLoaded = 1 Then
		$sText = "Folder (" & $sFolder
	Else
		$sText = "Files (" & $sFolder
	EndIf
	$sText &= $CDLabel & ")"
	_GUICtrlListView_SetColumn($ctrlView, 1, $sText)

	GUICtrlSendMsg($ctrlView, $LVM_SETITEMCOUNT, $iRows, 0)

	If $iFolderLoaded = 1 And Not StringInStr($aFiles[1][0], ":\") Then
		GUICtrlSetState($ctrlRescan, $GUI_ENABLE)
	EndIf
	GUICtrlSetState($idShuffle, $GUI_ENABLE)
	If $iShuffled = 1 Then
		GUICtrlSetState($ctrlReshuffle, $GUI_ENABLE)
	EndIf
	GUICtrlSetState($idFile, $GUI_ENABLE)
	GUICtrlSetState($idFolder, $GUI_ENABLE)
	If $itemHeight = 0 Then
		Local $aItemRect = _GUICtrlListView_GetItemRect($ctrlView, 0, 0)
		$itemHeight = $aItemRect[3] - $aItemRect[1]
		Local $hHeader = _GUICtrlListView_GetHeader($ctrlView)
		$headerHeight = _WinAPI_GetWindowHeight($hHeader)
	EndIf

	If $iListView = 1 Then
		GUISetState(@SW_SHOW, $hPlaylist)
	EndIf
	_PlaylistHighlight()
	GUIDelete($winLoading)

	$iAllDone = 0
	GUICtrlSetColor($idTitle, 0xFF0055)
	AdlibRegister("_GetLength", 25)
EndFunc		;==>_PlaylistLoad

Func _PlaylistMsg()	; Respond to GUIGetMsg() from playlist window
	If Not IsArray($aFiles) Then Return

	Local $clip, $id, $aList, $now, $hFile, $tFile, $str, $viewItemID, $found, $a, $sText
	Switch $aMsg[0]
		Case $GUI_EVENT_CLOSE
			_PlaylistShow()
		Case $GUI_EVENT_RESIZED
			$aPos = WinGetPos($hPlaylist)
			$w = $aPos[2]-$borderWidth*2
			GUICtrlSetPos($ctrlView, 0, 0, $aPos[2]-$borderWidth*2+2, $aPos[3]-$titleHeight-$borderWidth-87) ; +2 eliminates right-side black borderline
			_GUICtrlListView_SetColumnWidth($ctrlView, 0, $col1Width)
			_GUICtrlListView_SetColumnWidth($ctrlView, 1, $w-$col1Width-60-21)	; -21 eliminates horizontal scroll bar
			_GUICtrlListView_SetColumnWidth($ctrlView, 2, 60)
			_PlaylistHighlight()
		Case $ctrlSearchBox
			GUICtrlSetState($ctrlFind, $GUI_FOCUS)
		Case $ctrlFind
			$viewItemID = 0
			$str = StringStripWS(GUICtrlRead($ctrlSearchBox), 3)
			If $str = "" Then Return
			If (StringInStr(StringLeft($str, 1), '"') And StringRight($str, 1)) = '"' Or _
				(StringInStr(StringLeft($str, 1), "'") And StringRight($str, 1)) = "'" Then
				$str = StringMid($str, 2, StringLen($str)-2)
				For $y = 2 To $aFiles[0][0]
					If StringInStr($aFiles[$y][0], $str) Then
						$viewItemID = $y-1
						ExitLoop
					EndIf
				Next
			Else
				If StringInStr($str, " ") Then
					For $y = 2 To $aFiles[0][0]
						$found = True
						$a = StringSplit($str, " ")
						For $z = 1 To $a[0]
							If StringInStr($aFiles[$y][0], $a[$z]) Then
								$found = $found And True
							Else
								$found = $found And False
								ExitLoop
							EndIf
						Next
						If $found Then
							$viewItemID = $y-1
							ExitLoop
						EndIf
					Next
				Else
					For $y = 2 To $aFiles[0][0]
						If StringInStr($aFiles[$y][0], $str) Then
							$viewItemID = $y-1
							ExitLoop
						EndIf
					Next
				EndIf
			EndIf
			If $viewItemID = 0 Then
				Send("+{TAB}")
				$sMsg = "Cannot find the string..."
				MsgBox($MB_OK, "ListView", $sMsg, 3)
				GUICtrlSetState($ctrlSearchBox, $GUI_FOCUS)
			Else
				_GUICtrlListView_SetItemSelected($ctrlView, $viewItemID-1, True, True)
				_GUICtrlListView_Scroll($ctrlView, 0, $aFiles[0][0]*-$itemHeight)
				_GUICtrlListView_Scroll($ctrlView, 0, ($viewItemID+1-(ControlGetPos($hPlaylist, "", $ctrlView)[3])/$itemHeight/2)*$itemHeight)
				Send("{TAB}")
			EndIf
		Case $ctrlNext
			$str = StringStripWS(GUICtrlRead($ctrlSearchBox), 3)
			If $str = "" Then Return
			$now = _GUICtrlListView_GetSelectedIndices($ctrlView)
			$viewItemID = 0
			If (StringInStr(StringLeft($str, 1), '"') And StringRight($str, 1)) = '"' Or _
				(StringInStr(StringLeft($str, 1), "'") And StringRight($str, 1)) = "'" Then
				$str = StringMid($str, 2, StringLen($str)-2)
				For $y = $now+3 To $aFiles[0][0]
					If StringInStr($aFiles[$y][0], $str) Then
						$viewItemID = $y-1
						ExitLoop
					EndIf
				Next
			Else
				If StringInStr($str, " ") Then
					For $y = $now+3 To $aFiles[0][0]
						$found = True
						$a = StringSplit($str, " ")
						For $z = 1 To $a[0]
							If StringInStr($aFiles[$y][0], $a[$z]) Then
								$found = $found And True
							Else
								$found = $found And False
								ExitLoop
							EndIf
						Next
						If $found Then
							$viewItemID = $y-1
							ExitLoop
						EndIf
					Next
				Else
					For $y = $now+3 To $aFiles[0][0]
						If StringInStr($aFiles[$y][0], $str) Then
							$viewItemID = $y-1
							ExitLoop
						EndIf
					Next
				EndIf
			EndIf
			If $viewItemID = 0 Then
				Send("+{TAB}")
				Send("+{TAB}")
				$sMsg = "No more found..."
				MsgBox($MB_OK, "ListView", $sMsg, 3)
				GUICtrlSetState($ctrlSearchBox, $GUI_FOCUS)
			Else
				_GUICtrlListView_SetItemSelected($ctrlView, $viewItemID-1, True, True)
				_GUICtrlListView_Scroll($ctrlView, 0, $aFiles[0][0]*-$itemHeight)
				_GUICtrlListView_Scroll($ctrlView, 0, ($viewItemID+1-(ControlGetPos($hPlaylist, "", $ctrlView)[3])/$itemHeight/2)*$itemHeight)
			EndIf
		Case $ctrlRevert
			_PlaylistHighlight()
			GUICtrlSetState($ctrlView, $GUI_FOCUS)
		Case $ctrlRescan
			_Rescan()
		Case $ctrlReshuffle
			_ArrayShuffle($aFiles, 2)
			$hFile = FileOpen($sFolder & "zPlaylist-Shuffled.txt", 2+32)
			_FileWriteFromArray($hFile, $aFiles, 1, Default, ":|")
			FileClose($hFile)
			$iIndex = _ArraySearch($aFiles, $currentFile, 2)
			$sText = _GUICtrlListView_GetColumn($ctrlView, 1)[5]
			_PlaylistLoad()
			_GUICtrlListView_SetColumn($ctrlView, 1, $sText)	; To show total length of playlist
		Case $idSubmenuPlay
			$id = _GUICtrlListView_GetSelectedIndices($ctrlView)
			_DeleteContextMenu()
			If $aFiles[$id+2][0] = $currentFile Then Return
			GUICtrlSetData($idPlay, "❚❚")
			GUICtrlSetFont($idPlay, 18)
			GUICtrlSetPos($idPlay, 58, 45, 16, 18)
			$iRepeat = 1
			_Repeat()
			$iPaused = 0
			$iIndex = $id+1
			mciSendString("stop MyMedia")
			If $iMute = 1 Then _Mute()
		Case $idSubmenuFileInfo
			$filePropertiesFrom = _GUICtrlListView_GetSelectedIndices($ctrlView)	; Differentiate from function call by hotkey
			_DeleteContextMenu()
			$iProperties = 0
			_FilePropertiesShow()				; Hotkey for current file, context menu for selected item
			$filePropertiesFrom = ""
		Case $idSubmenuSearch
			$internetSearchFrom = _GUICtrlListView_GetSelectedIndices($ctrlView)	; Differentiate from function call by hotkey
			_DeleteContextMenu()
			_InternetSearch()					; Hotkey for current file, context menu for selected item
			$internetSearchFrom = ""
		Case $idSubmenuFolder
			$tFile = $aFiles[_GUICtrlListView_GetSelectedIndices($ctrlView)+2][0]
			_DeleteContextMenu()
			If StringInStr($tFile, ":\") Then
				$sPath = $tFile
			Else
				$sPath = $sFolder & $tFile
			EndIf
			RunWait("C:\Windows\explorer.exe /e," & '"' & StringLeft($sPath, StringInStr($sPath, "\", 0, -1)) & '"', "", @SW_MAXIMIZE)
			Sleep(1000)
			Send(StringMid($sPath, StringInStr($sPath, "\", 0, -1)+1))
		Case $idSubmenuRemove
			$id = _GUICtrlListView_GetSelectedIndices($ctrlView)+2
			_DeleteContextMenu()
			$clip = $aFiles[$id][0]
			Local $iRes = MsgBox($MB_YESNO, "Remove from playlist", $clip & @CRLF & "Remove this item from playlist?")
			If $iRes = $IDNO Then Return
			_ArrayDelete($aFiles, $id)
			If $id <= $iIndex Then
				$iIndex -= 1
			EndIf
			If $clip = $currentFile Then
				mciSendString("stop MyMedia")
			EndIf
			$aFiles[0][0] -= 1
			$aFiles[1][0] = $aFiles[$iIndex][0]
			If FileExists($sFolder & "zPlaylist-Shuffled.txt") Then
				_FileReadToArray($sFolder & "zPlaylist-Shuffled.txt", $aList, 1+4, ":|")
				$id = _ArraySearch($aList, $clip, 2)
				If $id >= 2 Then
					_ArrayDelete($aList, $id)
					$aList[1][0] = $aFiles[$iIndex][0]
					$hFile = FileOpen($sFolder & "zPlaylist-Shuffled.txt", 2+32)
					_FileWriteFromArray($hFile, $aList, 1, Default, ":|")
					FileClose($hFile)
				EndIf
			EndIf
			$aList = $aFiles
			_ArraySort($aList, 0, 2)
			$hFile = FileOpen($sFolder & "zPlaylist.txt", 2+32)
			_FileWriteFromArray($hFile, $aFiles, 1, Default, ":|")
			FileClose($hFile)
			_PlaylistLoad()
		Case $idPrefRadio1
			If BitAND(GUICtrlRead($idPrefRadio1), $GUI_CHECKED) = $GUI_CHECKED Then
				$resumeMode = "Never"
			EndIf
		Case $idPrefRadio2
			If BitAND(GUICtrlRead($idPrefRadio2), $GUI_CHECKED) = $GUI_CHECKED Then
				$resumeMode = "Ask"
			EndIf
		Case $idPrefRadio3
			If BitAND(GUICtrlRead($idPrefRadio3), $GUI_CHECKED) = $GUI_CHECKED Then
				$resumeMode = "Always"
			EndIf
		Case $idPrefTotal
			$minTotalLength = GUICtrlRead($idPrefTotal)
			GUICtrlSetState($idPrefPlayed, $GUI_FOCUS)
		Case $idPrefPlayed
			$minPlaybackLength = GUICtrlRead($idPrefPlayed)
			GUICtrlSetState($idPrefSave, $GUI_FOCUS)
		Case $idPrefSave
			GUICtrlSetData($idPrefSave, "SAVED")
			Sleep(1000)
			GUICtrlSetData($idPrefSave, "Save")
	EndSwitch
	If $iDoubleClicked = 1 Then
		$iDoubleClicked = 0
		$id = _GUICtrlListView_GetSelectedIndices($ctrlView)
		If $aFiles[$id+2][0] = $currentFile Then Return
		GUICtrlSetData($idPlay, "❚❚")
		GUICtrlSetFont($idPlay, 18)
		GUICtrlSetPos($idPlay, 58, 45, 16, 18)
		$iRepeat = 1
		_Repeat()
		$iPaused = 0
		$iIndex = $id+1
		mciSendString("stop MyMedia")
		If $iMute = 1 Then _Mute()
	EndIf
EndFunc   ;==>ListViewMsg

Func _PlaylistSave()	; Save playlist before the program leaves a folder: Change Folder, Unload, Terminate
	If $iFolderLoaded = 0 Or ($iPlaying = 1 And $iAllDone = 0) Then Return
	If IsArray($aFiles) = 0 Or $aFiles[0][0] < 2 Then Return
	Local $sPref = "", $iSeconds
	If $iCD = 0 Then
		If Int($iLength/1000) >= $minTotalLength Then
			$iSeconds = Int(mciSendString("status myMedia position")/1000)
			If $iSeconds >= $minPlaybackLength Then
				$sPref = "||" & $iSeconds
			Else
				$sPref = ""
			EndIf
		EndIf

		Local $hFile, $sList, $aFiles2
		$currentFile = StringSplit($aFiles[1][0], "||", 1)[1]
		If GUICtrlRead($idShuffle) = "Sort" Then	; $iShuffled = 1
			$aFiles[1][0] = $currentFile & "||Shuffled" & $sPref
			$hFile = FileOpen($sFolder & "zPlaylist-Shuffled.txt", 2+32)
			_FileWriteFromArray($hFile, $aFiles, 1, Default, ":|")
			FileClose($hFile)
			$aFiles2 = $aFiles
			_ArraySort($aFiles2, 0, 2)
			$hFile = FileOpen($sFolder & "zPlaylist.txt", 2+32)
			_FileWriteFromArray($hFile, $aFiles2, 1, Default, ":|")
			FileClose($hFile)
		Else
			$aFiles[1][0] = $currentFile & "||Sorted" & $sPref
			$hFile = FileOpen($sFolder & "zPlaylist.txt", 2+32)
			_FileWriteFromArray($hFile, $aFiles, 1, Default, ":|")
			FileClose($hFile)
			$sList = $sFolder & "zPlaylist-Shuffled.txt"
			If FileExists($sList) Then
				_FileReadToArray($sList, $aFiles2, 1+4, ":|")
				If IsArray($aFiles2) = 1 And $aFiles2[0][0] = $aFiles[0][0] Then
					$aFiles2[1][0] = $currentFile & "||Sorted" & $sPref
				Else
					$aFiles2 = $aFiles
					_ArrayShuffle($aFiles2, 2)
				EndIf
			Else
				$aFiles2 = $aFiles
				_ArrayShuffle($aFiles2, 2)
			EndIf
			$hFile = FileOpen($sList, 2+32)
			_FileWriteFromArray($hFile, $aFiles2, 1, Default, ":|")
			FileClose($hFile)
		EndIf
	Else
		Local $CDID = "CDID=" & $aTracks[0]
		$CDID &= "|" & $iCDLength
		$CDID &= "|" & $iTrack
		$CDID &= "|" & $iLength
		$CDID &= "|" & DriveGetLabel($sFolder)
		$CDID &= @LF & "Play Mode="
		If $iShuffled = 1 Then
			$CDID &= "Shuffled"
		Else
			$CDID &= "Sorted"
		EndIf
		If Int($iLength/1000) >= $minTotalLength Then
			$iTrackPlayedLength = Int($iTrackPlayedLength/1000)
			If $iTrackPlayedLength >= $minPlaybackLength Then
				$CDID &= "|" & $iTrackPlayedLength
			EndIf
		EndIf

		If Not FileExists($iniFile) Then
			$hFile = FileOpen($iniFile, 2+32)
			FileWriteLine($hFile, "[Audio CD]")
			FileWrite($hFile, $CDID)
			FileClose($hFile)
		Else
			$CDID &= @LF & "Playlist=" & IniRead($iniFile, "Audio CD", "Playlist", "")
			IniWriteSection($iniFile, "Audio CD", $CDID)
		EndIf

		If $iShuffled = 1 Then
			$CDID = ""
			For $i = 2 To $aFiles[0][0]-1
				$CDID &= $aFiles[$i][0] & "|"
			Next
			$CDID &= $aFiles[$i][0]
			IniWrite($iniFile, "Audio CD", "Playlist", $CDID)
		EndIf
	EndIf
	$iPlayListSaved = 1
EndFunc		;==>_PlaylistSave

Func _PlaylistShow()	; Show the playlist (Click title display control, or press Ctrl+Alt+L)
	If GUICtrlRead($idTitle) = "Media title" Then Return
	If $iListView = 0 Then
		If $iFullScreen = 1 Then	; If video is in fullscreen mode, maximize it
			$iMaximized = 1
			_FullScreen()
		EndIf
		$aPos= WinGetPos($hPlaylist)
		WinMove($hPlaylist, "", (@DesktopWidth-$aPos[2])/2, 0)
		GUISetState(@SW_SHOW, $hPlaylist)
		_PlaylistHighlight()
		GUICtrlSetState($ctrlView, $GUI_FOCUS)
		$iListView = 1
	Else
		GUISetState(@SW_HIDE, $hPlaylist)
		$iListView = 0
	EndIf
EndFunc		;==>_PlaylistShow

Func _ProgressBar()	; Adlib function to display progress of playback
	Local $mediaPos = mciSendString("status myMedia position")
	If $iTrack > 0 Then
		$mediaPos = $mediaPos - $iTrackPos
		$iTrackPlayedLength = $mediaPos
	EndIf
	GUICtrlSetPos($idProgBar, $xOffset+$mediaPos/$iLength*$sliderLength)
	GUICtrlSetPos($idProgBar2, $mediaPos/$iLength*$sliderLength2)

	Local $tSeconds = Int($mediaPos/1000)
	Local $iMinutes = Int($tSeconds/60)
	Local $iSeconds = StringFormat("%02i", $tSeconds-$iMinutes*60)
	If GUICtrlRead($idCurrentPos) <> $iMinutes & ":" & $iSeconds Then
		GUICtrlSetData($idCurrentPos, $iMinutes & ":" & $iSeconds)
		If $iMinutes > 59 Then
			Local $iHours = Int($iMinutes/60)
			$iMinutes = StringFormat("%02i", $iMinutes-$iHours*60)
			GUICtrlSetData($idCurrentPos2, $iHours & ":" & $iMinutes & ":" & $iSeconds)
		Else
			GUICtrlSetData($idCurrentPos2, $iMinutes & ":" & $iSeconds)
		EndIf
	EndIf
EndFunc		;==>_ProgressBar

Func _Repeat()	; Repeat current file on/off (Click center of ◀U▶ icon or press Ctrl+Alt+r)
	If $iRepeat = 0 Then
		$iRepeat = 1
		GUICtrlSetData($idRepeat, "0")			; The curent file will be repeated
		GUICtrlSetData($idRepeat2, "0")
	Else
		$iRepeat = 0
		GUICtrlSetData($idRepeat, "U")			; No repeat
		GUICtrlSetData($idRepeat2, "U")
	EndIf
EndFunc		;==>_Repeat

Func _Rescan()	; Rescan the folder and refresh the playlist
	Local $aList, $hFile
	Local $fileTypes = "*." & StringReplace($sFileTypes, " ", ";*.")
	$aList = _FileListToArrayRec($sFolder, $fileTypes, 1, 1, 1, 1)

	Local $iRootFolders, $iSubFolders, $iRet
	For $i = 1 To $aList[0]
		If StringInStr($aList[$i], "\") Then
			$iSubFolders += 1
		Else
			$iRootFolders += 1
		EndIf
	Next
	If $iSubFolders > 0 And $iRootFolders > 0 Then
		Local $sMsg = "Number of files in top-level folder:" & @TAB & $iRootFolders & @CRLF
		$sMsg &= "Number of files in sub-level folders:" & @TAB & $iSubFolders & @CRLF & @CRLF
		$sMsg &= "Do you want to include files in the subfolders?"
		$iRet = MsgBox($MB_YESNO, "Include files in subfolders?", $sMsg)
	EndIf
	If $iRet = $IDNO Then
		$aList = _FileListToArrayRec($sFolder, $fileTypes, 29, 0, 1, 1) ; exclude files in subfolders
	EndIf

	_ArrayInsert($aList, 1, $currentFile)
	$aList[0] += 1
	_ArrayColInsert($aList, 1)

	If $iShuffled = 0 Then
		$hFile = FileOpen($sFolder & "zPlaylist.txt", 2+32)
		FileDelete($sFolder & "zPlaylist-Shuffled.txt")
	Else
		_ArrayShuffle($aList, 2)
		$hFile = FileOpen($sFolder & "zPlaylist-Shuffled.txt", 2+32)
		FileDelete($sFolder & "zPlaylist.txt")
	EndIf
	_FileWriteFromArray($hFile, $aList, 1, Default, ":|")
	FileClose($hFile)

	$aFiles = $aList
	$iIndex = _ArraySearch($aFiles, $currentFile, 2)
	If $iIndex = -1 Then
		$iRescanned = 1	; $iIndex becomes 2 per _PlaylistLoad() and not adjusted in main While loop
		mciSendString("stop myMedia")
	EndIf
	_PlaylistLoad()
EndFunc		;==>_Rescan

Func _Shuffle()	; Shuffle or sort playlist
	If GUICtrlGetState($idShuffle) > 80 Then Return	; $idShuffle is disabled
	If $iShuffled = 0 Then
		$iShuffled = 1
	Else
		$iShuffled = 0
	EndIf
	Local $sText = _GUICtrlListView_GetColumn($ctrlView, 1)[5]
	_PlaylistLoad()
	_GUICtrlListView_SetColumn($ctrlView, 1, $sText)	; To show total length of playlist
EndFunc		;==>_Shuffle

Func _Slider($hWnd)	; Drag and drop the progrss bar or click anywhere on the slider to jump to a new media position
	AdlibUnRegister("_ProgressBar")
	Local $aPos = WinGetPos($hWnd), $x, $x2, $borderWidth, $mediaPos
	If $hWnd = $hMain Then
		$borderWidth = 3
	EndIf
	While _IsPressed("01") = 1	; Left mouse button
		If $hWnd = $hMain Then
			$x = MouseGetPos(0)-($aPos[0]+$borderWidth+$xOffset+$progbarWidth/2)	; Mouse position relative to slider position
			If $x > $sliderLength Then												; Effective slider length = actual length - progress bar width
				$x = $sliderLength
			ElseIf $x < 0 Then
				$x = 0
			EndIf
			GUICtrlSetPos($idProgBar, $x+$xOffset)
			GUICtrlSetPos($idProgBar2, $x/$sliderLength*$sliderLength2)
			$mediaPos = Int($x/$sliderLength*$iLength)
		ElseIf $hWnd = $vcGUI Then
			$x2 = MouseGetPos(0)-($aPos[0]+$progbarWidth/2)
			If $x2 > $sliderLength2 Then
				$x2 = $sliderLength2
			ElseIf $x2 < 0 Then
				$x2 = 0
			EndIf
			GUICtrlSetPos($idProgBar2, $x2)
			GUICtrlSetPos($idProgBar, $x2/$sliderLength2*$sliderLength+$xOffset)
			$mediaPos = Int($x2/$sliderLength2*$iLength)
		EndIf
		Local $tSeconds = Int($mediaPos/1000)
		Local $iMinutes = Int($tSeconds/60)
		Local $iSeconds = StringFormat("%02i", $tSeconds-$iMinutes*60)
		GUICtrlSetData($idCurrentPos, $iMinutes & ":" & $iSeconds)
		If $iMinutes > 59 Then
			Local $iHours = Int($iMinutes/60)
			$iMinutes = StringFormat("%02i", $iMinutes-$iHours*60)
			GUICtrlSetData($idCurrentPos2, $iHours & ":" & $iMinutes & ":" & $iSeconds)
		Else
			GUICtrlSetData($idCurrentPos2, $iMinutes & ":" & $iSeconds)
		EndIf
		Sleep(1)
	WEnd
	$iPlaying = 0
	mciSendString("stop myMedia")
	If $mediaPos < 50 Then $mediaPos = 50	; Skip beginning noise
	If $iTrack > 0 Then
		mciSendString("seek myMedia to " & $iTrackPos+$mediaPos)
	Else
		mciSendString("seek myMedia to " & $mediaPos)
	EndIf
	mciSendString("play myMedia")
	GUICtrlSetData($idPlay2, "❚❚")
	GUICtrlSetFont($idPlay2, 18)
	GUICtrlSetPos($idPlay2, $vcWidth/2-58, 16, 16, 18)
	$iPaused = 0
	$iPlaying = 1
	AdlibRegister("_ProgressBar", 250)
	If $hWnd = $hMain Then
	EndIf
EndFunc		;==>_Slider

Func _Unload()	; Triggered by Unload button or Ctrl+Alt+u hotkey
	_PlaylistSave()	; Playlist should be saved before mciSendString("close myMedia")
	$iPlayListSaved = 1
	AdlibUnRegister("_VolumeSync")
	_Unload_2()
EndFunc		;==>_Unload

Func _Unload_1()	; Partial initialization triggered by 'Unload/Change Folder' button
	AdlibUnRegister("_GetLength")
	$iAllDone = 0
	$iDoing = 0
	$iPlaying = 0
	$iPaused = 0
	$iVideo = 0
	$iShuffled = 0
	_ABRepeatCancel(1)
	_FileRepeatCancel("_Unload_1")
	GUISetState(@SW_HIDE, $hABRepeat)
	$sFilesToRepeat = ""
	GUISetState(@SW_HIDE, $hFilesRepeat)
	$iRepeat = 1
	_Repeat()
	mciSendString("close myMedia")
	GUISetState(@SW_HIDE, $hVideoGUI)
EndFunc		;==>_Unload_1

Func _Unload_2()	; Complete initialization triggered by 'Unload' button or Ctrl+Alt+u
	If $iAllDone = 0 Then
		Return
	EndIf
	_Unload_1()
	GUIDelete($hPlaylist)
	$hPlaylist = ""
	GUISetStyle($WS_OVERLAPPEDWINDOW, -1, $hVideoGUI)
	GUISetState(@SW_RESTORE, $hVideoGUI)
	$iFullScreen = 0
	$iMaximized = 0
	$iFolderLoaded = 0
	GUISetState(@SW_HIDE, $hProperties)
	WinSetOnTop($hVideoGUI, "", 0)
	GUICtrlSetData($idFile, "Load File")
	GUICtrlSetState($idFile, $GUI_ENABLE)
	GUICtrlSetPos($idFile, 155, 45, 61, 24)
	GUICtrlSetData($idFolder, "Load Folder")
	GUICtrlSetState($idFolder, $GUI_ENABLE)
	GUICtrlSetPos($idFolder, 216, 45, 79, 24)
	GUICtrlSetData($idPlay, "▶")
	GUICtrlSetFont($idPlay, 10)
	GUICtrlSetPos($idPlay, 60, 51, 16, 15)
	GUICtrlSetState($idTitle, $GUI_DISABLE)
	GUICtrlSetState($idSlider, $GUI_DISABLE)
	GUICtrlSetData($idShuffle, "Shuffle")
	GUICtrlSetState($idShuffle, $GUI_DISABLE)
	GUICtrlSetState($idPlay, $GUI_DISABLE)
	GUICtrlSetState($idPrevious, $GUI_DISABLE)
	GUICtrlSetState($idRepeat, $GUI_DISABLE)
	GUICtrlSetState($idNext, $GUI_DISABLE)
	GUICtrlSetState($idSpeaker, $GUI_DISABLE)
	AdlibUnRegister("_ProgressBar")
	AdlibUnRegister("_Marquee")
	AdlibUnRegister("_VCShow")
	GUICtrlSetData($idTitle, "Media title")
	GUICtrlSetData($idCurrentPos, "00:00")
	GUICtrlSetData($idLength, "00:00")
	GUICtrlSetPos($idProgBar, $xOffset)
	WinSetTitle($hMain, "", $guiTitle)
	$aFiles = ""
	$sFile = ""
	$sFolder = ""
	$aItems = ""
	ReDim $aColors[0][3]
	_WinAPI_SetThreadExecutionState($ES_CONTINUOUS)	; Back to normal windows behavior
EndFunc		;==>_Unload_2

Func _VCCreate($tString)	; A new $hVideo window is created every time a new file is opened, requiring new $vcGUI as its child
	GUIDelete($vcGUI)   	; _WinAPI_SetParent is not applicable because $hVideo is created by winmm.dll
	$vcGUI = ""
	$vcWidth = $videoWidth
	$vcLeft = (@DesktopWidth-$vcWidth)/2
	$vcTop = $scrHeight/2
	$vcGUI = GUICreate("", $vcWidth, $vcHeight, $vcLeft, $vcTop, $WS_POPUP, $WS_EX_LAYERED, $hVideo)
	$idSlider2 = GUICtrlCreateLabel("", 0, 0, $vcWidth, 14, $SS_NOPREFIX+$SS_LEFTNOWORDWRAP)
	GUICtrlSetBkColor(-1, Dec("D0D0D0"))
	GUICtrlSetFont(-1, 10)
	GUICtrlSetResizing(-1, $GUI_DOCKBORDERS)
	$idABRepeat2 = GUICtrlCreateLabel("", 0, 2, 10, 12)	; Pink bar to indicate A-B repeat positions in slider
	GUICtrlSetBkColor(-1, 0xD580FF)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
	GUICtrlSetState(-1, $GUI_HIDE)
	$idProgBar2 = GUICtrlCreateLabel("", 0, 2, $progbarWidth, 12)
	GUICtrlSetBkColor(-1, 0x566573)
	GUICtrlSetResizing(-1, $GUI_DOCKSIZE)
	$idCurrentPos2 = GUICtrlCreateLabel("00.00", 10, 18, 50, 15, $SS_LEFT)
	GUICtrlSetFont(-1, 10, 600)
	GUICtrlSetResizing(-1, $GUI_DOCKLEFT+$GUI_DOCKSIZE)
	$idLength2 = GUICtrlCreateLabel($tString, $vcWidth-60, 18, 50, 15, $SS_RIGHT)
	GUICtrlSetFont(-1, 10, 600)
	GUICtrlSetResizing(-1, $GUI_DOCKRIGHT+$GUI_DOCKSIZE)
	If $sFilesToRepeat <> "" Then
		GUICtrlSetColor($idLength2, 0xFF0055)
	EndIf
	$idExit = GUICtrlCreateLabel("🞭", $vcWidth/2-98, 14, 15, 25, $SS_CENTER)
	GUICtrlSetFont(-1, 20, 400)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPlay2 = GUICtrlCreateLabel("❚❚", $vcWidth/2-58, 16, 16, 18, $SS_CENTER)
	GUICtrlSetFont($idPlay2, 18, 100)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idPrevious2 = GUICtrlCreateLabel("◀", $vcWidth/2-26, 22, 15, 15, $SS_CENTER)
	GUICtrlSetFont(-1, 10)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	If $iRepeat = 1 Then
		$idRepeat2 = GUICtrlCreateLabel("0", $vcWidth/2-11, 21, 14, 15, $SS_CENTER)
	Else
		$idRepeat2 = GUICtrlCreateLabel("U", $vcWidth/2-11, 21, 14, 15, $SS_CENTER)
	EndIf
	GUICtrlSetFont(-1, 10, 900)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idNext2 = GUICtrlCreateLabel("▶", $vcWidth/2+3, 22, 15, 15, $SS_CENTER)
	GUICtrlSetFont(-1, 10)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idSpeaker2 = GUICtrlCreateLabel("🔊", $vcWidth/2+32, 18, 15, 18, $SS_CENTER)
	GUICtrlSetFont(-1, 15, 400)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idUp2 = GUICtrlCreateLabel("▲", $vcWidth/2+48, 14, 15, 15, $SS_CENTER)
	GUICtrlSetFont(-1, 10)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetTip(-1, $iVolume)
	$idDown2 = GUICtrlCreateLabel("▼", $vcWidth/2+48, 27, 15, 15, $SS_CENTER)
	GUICtrlSetFont(-1, 10)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetTip(-1, $iVolume)
	$idFullScreen = GUICtrlCreateLabel("⇔", $vcWidth/2+80, 20, 20, 20, $SS_CENTER)
	GUICtrlSetFont(-1, 12, 600)
	If $iFullScreen = 1 Then
		GUICtrlSetData($idFullScreen, "⇙")
		GUICtrlSetFont(-1, 20, 600)
		GUICtrlSetPos(-1, $vcWidth/2+80, 15, 20, 20)
	EndIf
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	$idVolume2 = GUICtrlCreateButton($iVolume, $vcWidth/2+58, 5, 25, 25)
	GUICtrlSetResizing(-1, $GUI_DOCKHCENTER+$GUI_DOCKBOTTOM+$GUI_DOCKSIZE)
	GUICtrlSetState(-1, $GUI_HIDE)
EndFunc		;==>_VCCreate

Func _VCResize()	; Adlib function to resize $vcGUI to fit $hVideo at 500 ms interval
	If Not WinExists($hVideo) Then Return
	$aPos = WinGetPos($hVideo)
	$vcWidth = $aPos[2]
	$sliderLength2 = $vcWidth-$progbarWidth
	WinMove($vcGUI, "", $aPos[0], $aPos[1]+$aPos[3]-$vcHeight, $vcWidth, $vcHeight)
	If $iPaused = 0 Then
		GUICtrlSetPos($idPlay2, $vcWidth/2-58, 16, 16, 18)
	Else
		GUICtrlSetPos($idPlay2, $vcWidth/2-56, 22, 16, 18)
	EndIf
	If $iFullScreen = 0 Then
		GUICtrlSetPos($idFullScreen, $vcWidth/2+80, 20, 20, 20)
	Else
		GUICtrlSetPos($idFullScreen, $vcWidth/2+80, 15, 20, 20)
	EndIf
EndFunc		;==>_VCResize

Func _VCShow()	; Adlib function to show video control when mouse pointer enters the lower side of video window
	If WinGetState($hVideoGUI) < 7 Then Return
	Local $aPos = WinGetPos($hVideo), $iLeft, $iTop, $iRight, $iBottom
	If Not IsArray($aPos) Then Return
	$iLeft = $aPos[0]
	$iRight = $aPos[0]+$aPos[2]
	$iBottom = $aPos[1]+$aPos[3]
	$iTop = _Max($iBottom-150, $aPos[1])
	Local $iX = MouseGetPos(0), $iY = MouseGetPos(1), $iTransColor, $iAlpha
	_WinAPI_GetLayeredWindowAttributes($vcGUI, $iTransColor, $iAlpha)
	If $iAlpha <> 0 And ($iX <= $iLeft Or $iX >= $iRight Or $iY <= $iTop Or $iY >= $iBottom) Then
		_WinAPI_SetLayeredWindowAttributes($vcGUI, 0xABCDEF, 0)
	ElseIf $iAlpha <> 100 And $iX > $iLeft And $iX < $iRight And $iY > $iTop And $iY < $iBottom Then
		_WinAPI_SetLayeredWindowAttributes($vcGUI, 0xABCDEF, 100)
	EndIf
EndFunc		;==>_VCShow

Func _VideoResize($iWidth)	; Resize $hVieoGUI and $hVideo except when the window is in maximized or fullsreen mode
	_WinAPI_SetLayeredWindowAttributes($vcGUI, 0xABCDEF, 0)
	$videoWidth = $iWidth
	$videoHeight = Round($videoWidth/$imgRatio)
	If $videoHeight > $scrHeight-$titleHeight-$borderWidth Then
		$videoHeight = $scrHeight-$titleHeight-$borderWidth
		$videoWidth = Round($videoHeight*$imgRatio)
	EndIf
	$w = $videoWidth+$borderWidth*2
	$h = $videoHeight+$titleHeight+$borderWidth
	$x = (@DesktopWidth-$w)/2
	$y = ($scrHeight-$videoHeight-$titleHeight)/2
	WinMove($hVideoGUI, "", $x, $y, $w, $h)
	$x = $x+$borderWidth
	$y = $y+$titleHeight
	$w = $videoWidth
	$h = $videoHeight
	WinMove($hVideo, "", $x, $y, $w, $h)
	GUISetState(@SW_SHOW, $hVideoGUI)
EndFunc		;==>_VideoResize

Func _VolumeDown()	; Decrease audio volune by 10 percentage points (Click ▼ icon on graphical control or press Ctrl+Alt+down arrow)
	If $iMute = 1 Then _Mute()
	$iVolume -= 10
	$iVolume = _Max($iVolume, 0)
	DllCall($hDLL, "int", "waveOutSetVolume", "int", 0 , "int", Int($iVolume*655.35))
	_VolumeShow()
EndFunc		;==>_VolumeDown

Func _VolumeShow()	; Show current volume
	GUICtrlSetData($idVolume, $iVolume)
	GUICtrlSetData($idVolume2, $iVolume)
	GUICtrlSetState($idVolume, $GUI_SHOW)
	GUICtrlSetState($idVolume2, $GUI_SHOW)
	Sleep(200)
	GUICtrlSetState($idVolume, $GUI_HIDE)
	GUICtrlSetState($idVolume2, $GUI_HIDE)
	GUICtrlSetTip($idUp, $iVolume)
	GUICtrlSetTip($idUp2, $iVolume)
	GUICtrlSetTip($idDown, $iVolume)
	GUICtrlSetTip($idDown2, $iVolume)
EndFunc		;==>_VolumeShow

Func _VolumeSync()	; If volume was changed via Windows Settings, sync $iVolume
	Local $aRet = DllCall($hDLL, "int", "waveOutGetVolume", "ptr", 0, "DWORD*", 0)
	Local $nRet = Round($aRet[2]/655.35/10)*10
	If $iVolume <> $nRet Then
		$iVolume = $nRet
		DllCall($hDLL, "int", "waveOutSetVolume", "int", 0 , "int", Int($nRet*655.35))
		_VolumeShow()
	EndIf

	$muteState = _Audio_Action("GetMute", $gPID, True)
	; $muteState is 0 if unmuted, 1 if muted by click on Mixer mute icon, -1 if muted by click on zPlayer mute icon(SetMute)

	If $muteState = 1 And $iMute = 0 Then
		$iMute = 1
		GUICtrlSetData($idSpeaker, "🔇")
		GUICtrlSetData($idSpeaker2, "🔇")
	ElseIf $muteState = 0 And $iMute = 1 Then
		$iMute = 0
		GUICtrlSetData($idSpeaker, "🔊")
		GUICtrlSetData($idSpeaker2, "🔊")
	EndIf
EndFunc		;_VolumeSync

Func _VolumeUp()    ; Increase audio volume by 10 percentage points (Click ▲ icon on graphical control or press Ctrl+Alt+up arrow)
	If $iMute = 1 Then _Mute()
	$iVolume += 10
	$iVolume = _Min($iVolume, 100)
	DllCall($hDLL, "int", "waveOutSetVolume", "int", 0 , "int", Int($iVolume*655.35))
	_VolumeShow()
EndFunc		;==>_VolumeUp

Func _WinDefaultPos()	; Triggered by Ctrl+Alt+w, bring up all open GUIs to foreground and move them to their default positions
	GUISetState(@SW_RESTORE, $hMain)
	WinMove($hMain, "", 0, 0)
	$aPos = WinGetPos($hMain)
	$w = ($aPos[2]-$guiWidth)/2	; $border width of main GUI
	WinMove($hFilesRepeat, "", $aPos[0]+$guiWidth+$w, $aPos[1]+1)
	WinMove($hABRepeat, "", $aPos[0]-$ABRepeatWidth, $aPos[1]+1)
	$aPos = WinGetPos($hHelp)
	WinMove($hHelp, "", (@DesktopWidth-$aPos[2])/2, 0)
	If WinExists($hPlaylist) Then
		$x = (@DesktopWidth-$listWidth)/2-$borderWidth
		WinMove($hPlaylist, "", $x, 0, $listWidth+$borderWidth*2, $listHeight+$titleHeight)
		$aPos= WinGetPos($hPlaylist)
		GUICtrlSetPos($ctrlView, 0, 0, $aPos[2]-$borderWidth*2+2, $aPos[3]-$titleHeight-$borderWidth-87) ; +2 eliminates right-side black borderline
		_GUICtrlListView_SetColumnWidth($ctrlView, 0, $col1Width)
		_GUICtrlListView_SetColumnWidth($ctrlView, 1, $listWidth-$col1Width-60-21)	; -21 eliminates horizontal scroll bar
		_GUICtrlListView_SetColumnWidth($ctrlView, 2, 60)
		WinActivate($hPlaylist)
		_PlaylistHighlight()
	EndIf
	If $iListView = 1 Then
		$aPos= WinGetPos($hPlaylist)
		WinMove($hProperties, "", $aPos[0]+$aPos[2]/2, 0, $propertyWidth+$borderWidth*2, $propertyHeight+$titleHeight+$borderWidth)
	Else
		WinMove($hProperties, "", (@DesktopWidth-$propertyWidth)/2-$borderWidth, 0, $propertyWidth+$borderWidth*2, $propertyHeight+$titleHeight+$borderWidth)
	EndIf
	_GUICtrlListView_SetColumnWidth($idPropertiesView, 1, $propertyWidth-$nameWidth-15)
	WinActivate($hProperties)
	If $iVideo = 1 Then
		If $iFullScreen = 1 Then
			_FullScreen()
		EndIf
		$iMaximized = 0
		GUISetState(@SW_RESTORE, $hVideoGUI)
		_VideoResize(Int(@DesktopWidth/3*2))
		WinSetState($hVideo, "", @SW_SHOW)
		GUISetState(@SW_SHOW, $vcGUI)
	Else
		GUISetState(@SW_HIDE, $hVideoGUI)
	EndIf
EndFunc		;==>_WinDefaultPos

Func mciSendString($string)    ; Send command string to winmm.dll - https://learn.microsoft.com/en-us/windows/win32/multimedia/multimedia-command-strings
	Local $aRet = DllCall($hDLL, "int", "mciSendStringW", "wstr", $string, "wstr", "", "int", 65534, "hwnd", 0)
	If Not @error Then Return $aRet[2]
EndFunc		;==>mciSendString

Func WM_MOVE($hWnd, $MsgID, $wParam, $lParam)	; Move $vcGUI to new position when $hVideoGUI moves
	#forceref $hWnd, $MsgID, $wParam, $lParam
	If $hWnd <> $hVideoGUI Or $iFullScreen = 1 Or $iMaximized = 1 Then Return $GUI_RUNDEFMSG
	$aPos = WinGetPos($hVideoGUI)
	Local $x1, $y1, $w1, $h1
	$x1 = $aPos[0]+$borderWidth
	$y1 = $aPos[1]+$titleHeight
	$w1 = $aPos[2]-$borderWidth*2
	$h1 = $aPos[3]-$titleHeight-$borderWidth
	WinMove($hVideo, "", $x1, $y1, $w1, $h1)
	Sleep(10)
	Return $GUI_RUNDEFMSG
EndFunc		;==>WM_MOVE

Func WM_NOTIFY($hWnd, $MsgID, $wParam, $lParam)	; Detect mouse click on a playlist item
	#forceref $hWnd, $MsgID, $wParam, $lParam
	Local $tagNMHDR = DllStructCreate("int;int;int", $lParam)
	If @error Then Return $GUI_RUNDEFMSG
	Local $iCode = DllStructGetData($tagNMHDR, 3)

	If $hWnd = $hPlaylist And $wParam = $ctrlView Then ;Return $GUI_RUNDEFMSG
		Switch $iCode
			Case $NM_DBLCLK
				_DeleteContextMenu()
				If _GUICtrlListView_GetSelectedIndices($ctrlView) = "" Then
					_PlaylistHighlight()
				Else
					$iDoubleClicked = 1
				EndIf
			Case $NM_RCLICK
				_DeleteContextMenu()
				If _GUICtrlListView_GetSelectedIndices($ctrlView) = "" Then
					_PlaylistHighlight()
				Else
					; Existing context menu was deleted in main while loop
					$idContextmenu = GUICtrlCreateContextMenu($ctrlView)
					$idSubmenuPlay = GUICtrlCreateMenuItem("Play this file", $idContextmenu)
					$idSubmenuFileInfo = GUICtrlCreateMenuItem("File properties", $idContextmenu)
					$idSubmenuSearch = GUICtrlCreateMenuItem("Search internet", $idContextmenu)
					$idSubmenuFolder = GUICtrlCreateMenuItem("Go to this folder", $idContextmenu)
					If $sFilesToRepeat = "" Then
						$idSubmenuRemove = GUICtrlCreateMenuItem("Remove from playlist", $idContextmenu)
					EndIf
				EndIf
			Case $NM_CLICK, $NM_RDBLCLK
				_DeleteContextMenu()
				If _GUICtrlListView_GetSelectedIndices($ctrlView) = "" Then
					_PlaylistHighlight()
				EndIf
			Case $LVN_GETDISPINFOW
				; Fill virtual listview
				; https://www.autoitscript.com/forum/topic/168707-listview-item-subitem-background-colour/#comment-1234009
				Local $tNMLVDISPINFO = DllStructCreate( $tagNMLVDISPINFO, $lParam )
				If BitAND( DllStructGetData( $tNMLVDISPINFO, "Mask" ), $LVIF_TEXT ) Then
					Local $sItem = $aItems[DllStructGetData($tNMLVDISPINFO,"Item")][DllStructGetData($tNMLVDISPINFO, "SubItem")]
					DllStructSetData( $tText, 1, $sItem )
					DllStructSetData( $tNMLVDISPINFO, "TextMax", StringLen( $sItem ) )
					DllStructSetData( $tNMLVDISPINFO, "Text", DllStructGetPtr( $tText ) )
				EndIf
			Case $NM_CUSTOMDRAW
				Local $tNMLVCUSTOMDRAW = DllStructCreate($tagNMLVCUSTOMDRAW, $lParam)
				Local $dwDrawStage = DllStructGetData($tNMLVCUSTOMDRAW, "dwDrawStage")
				Switch $dwDrawStage                ; Holds a value that specifies the drawing stage
					Case $CDDS_PREPAINT
						; Before the paint cycle begins
						Return $CDRF_NOTIFYITEMDRAW    ; Notify the parent window of any item-related drawing operations
					Case $CDDS_ITEMPREPAINT
						; Before painting an item
						Return $CDRF_NOTIFYSUBITEMDRAW ; Notify the parent window of any subitem-related drawing operations
					Case BitOR( $CDDS_ITEMPREPAINT, $CDDS_SUBITEM )
						; Before painting a subitem
						;Local $iItem = DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")                ; Item index
						;Local $iSubItem = DllStructGetData($tNMLVCUSTOMDRAW, "iSubItem")               ; Subitem index
						;DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", $aColors[$iItem][$iSubItem] ) ; Backcolor of item/subitem
						DllStructSetData( $tNMLVCUSTOMDRAW, "ClrTextBk", $aColors[DllStructGetData($tNMLVCUSTOMDRAW, "dwItemSpec")][DllStructGetData($tNMLVCUSTOMDRAW, "iSubItem")] )
						Return $CDRF_NEWFONT           ; $CDRF_NEWFONT must be returned after changing font or colors
				EndSwitch
		EndSwitch
	ElseIf $hWnd = $hProperties And $iCode = $NM_DBLCLK Then
		Local $sMsg = "Copied to clipboard:" & @CRLF & @CRLF & $aFileInfo[_GUICtrlListView_GetSelectedIndices($idPropertiesView)][1]
		MsgBox(0, "File Properties", $sMsg, 3)
		ClipPut($aFileInfo[_GUICtrlListView_GetSelectedIndices($idPropertiesView)][1])
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc		;==>WM_NOTIFY

Func zPlayerHelp()	; Compose contents of Help window
	Local $sText = "zPayer is a stand-alone media player written in pure AutoIt, with the following functions:" & @CRLF & @CRLF & _
	"Click		Press		Function" & @CRLF & _
	"------		-------		-----------" & @CRLF & _
	"Load File				Load file(s) or CD tracks to playlist and start playing" & @CRLF & _
	"Load Folder			Load a folder or a CD to playlist and start playing" & @CRLF & _
	"Change Folder	Ctrl+Alt+c		Load a new folder and its subfolders" & @CRLF & _
	"Unload		Ctrl+Alt+u		Close current media and unload playlist" & @CRLF & _
	"Media title	Ctrl+Alt+L		Show/Hide playlist (context menu available)" & @CRLF & _
	"Shuffle/Sort	Ctrl+Alt+s		Load shuffled or sorted playlist" & @CRLF & _
	"Progress Bar			Click and drag progress bar to change playback position" & @CRLF & _
	"Current media position		Set A-B repeat positions" & @CRLF & _
	"Total media length			Set multi-file repeat function" & @CRLF & _
	"zPlayer icon on Windows taskbar	Minimize/Restore all open windows" & @CRLF & _
	"		Ctrl+Alt+w		Move all GUIs to default positions and bring them to foreground" & @CRLF & _
	"▶/❚❚		Ctrl+Alt+p		Play/Pause" & @CRLF & _
	"◀		Ctrl+Alt+Left	Play previous file" & @CRLF & _
	"▶		Ctrl+Alt+Right	Play next file" & @CRLF & _
	"U		Ctrl+Alt+r		Repeat/Unrepeat current file" & @CRLF & _
	"▲		Ctrl+Alt+Up	Volume up by 10% points" & @CRLF & _
	"▼		Ctrl+Alt+Down	Volume down by 10% points" & @CRLF & _
	"🔊/🔇		Ctrl+Alt+m	Turn audio on/off" & @CRLF & _
	"?		Ctrl+Alt+h		Show/Hide Help window" & @CRLF & _
	"⇔/⇙		F11/Esc		Turn video fullscreen on/off" & @CRLF & _
	"		Ctrl+Alt+i		Internet search results on current file" & @CRLF & _
	"		Ctrl+Alt+f		View file properties of current file" & @CRLF & _
	"🞭		Ctrl+Alt+End	Terminate the program" & @CRLF & @CRLF & _
	"When this program is run, it will look for zPlayer.ini file in the script directory. This file stores the playback settings of the last session such as folder and playlist loaded, mode of play (shuffled or sorted), volume and ‘Resume playback’ options in effect at the time the program was terminated. If the file exists, the player will resume these playback settings and start playing the stored playlist immediately." & @CRLF & @CRLF & _
	"If zPlayer.ini file does not exist in the script directory or if the folder stored in zPlayer.ini does not have a playlist file(zPlaylist.txt), the program will wait for you to select files or a folder to load into playlist. You can do this by clicking one of the two Load buttons: ‘Load File’ will load one or more files in a folder, and ‘Load Folder’ will load all the files in a folder. When you load a folder, you have an option to include or exclude files of the sub-folders in the playlist. This option applies only when the folder has media files in both top-level and sub-level folders and there is no existing playlist in that folder. Upon loading the files or a folder, the program will immediately start playing the playlist. If the Shuffle button is clicked any time thereafter, the playlist will be shuffled to a random order." & @CRLF & @CRLF & _
	"When you load a folder for the first time, the player will get media lengths in the background and fill the Length column of the playlist. During this time, media will keep playing but Shuffle/Sort, Load/Unload, Rescan and Reshuffle functions will be disabled and media title will be displayed in red color. This process will take about 15 seconds for a folder containing 500 media files." & @CRLF & @CRLF & _
	"This player will loop through the playlist endlessly unless you Unload the playlist, Change Folder, or terminate the program. If a folder has been loaded, the playlist will be saved in that folder just before the player leaves the folder. zPlaylist.txt stores sorted playlist and zPlaylist-Shuffled.txt the shuffled playlist. The first line of these playlists will contain the file name last played, playing mode and resume playback options in effect. You can switch between sorted and shuffled playlist by clicking Shuffle/Sort button or pressing Ctrl+Alt+s hotkey. For an audio CD last played, the playlist is saved in [Audio CD] section of zPlayer.ini file. When you come back to CD drive, zPlayer will first confirm whether the currently mounted CD is the same as the one last played, It confirmed, the previous playback environment will be resumed." & @CRLF & @CRLF & _
	"If you want to create a playlist of your own, create a file named zPlaylist.txt and populate the file with the full paths of your favorite titles leaving the first line empty. When you are done, copy the line you want to play first and paste it into the first line. This playlist may contain files from different folders. If you put this file in any folder, preferably an empty one with this file only, you can load this folder the same way as you load other folders with media files in them." & @CRLF & @CRLF & _
	"The current file name is displayed in the media title control of the main window. If the fille name is longer than the display control width, the file name will flow in marquee style." & @CRLF & @CRLF & _
	"The playlist is hidden by default. You can view it by clicking the media title control or pressing Ctrl+Alt+L hot keys. In the playlist window, you can search strings, rescan the folder or reshuffle the playlist. If you double-click a playlist item, that item will be played back. A right click on any item will bring up a context menu: available menus are ‘Play this file’, ‘File properties’, ‘Search internet’, ‘Go to this folder’ and ‘Remove from playlist’. File properties menu may not work properly under some earlier Windows versions, in which case you should change the File Property Column Numbers key of zPlayer.ini file to suit your OS. CD tracks do not contain metadata by design, rendering file properties irrelevant for them." & @CRLF & @CRLF & _
	"In the playlist window you can also set options for resuming playback from the last playback position. You can set minimum total length and minimum playback length of a file to resume the playback position. If you leave a folder in the middle of a file, these options will be saved and resumed when you come back to that folder." & @CRLF & @CRLF & _
	"When a video file is opened for playback, a separate video window will be opened and initially positioned at the center of desktop screen, with its width about 2/3 of the desktop width. The video window can be moved or resized during the play back, and the size of window will be forcefully adjusted to maintain the aspect ratio of source file. If you move the mouse to the lower side of video window, a graphical control will appear at the bottom of the video. You can turn fullscreen mode on or off by clicking ⇔/⇙ icon in the graphical control, or by pressing F11 key when the center point of video is visible. Once the video is maximized or turned into fullscreen, the player will play next files in that size." & @CRLF & @CRLF & _
	"Playback can be paused and resumed by clicking Play(▶)/Pause(❚❚) icon or pressing Ctrl+Alt+p." & @CRLF & @CRLF & _
	"You can move to the previous file or to the next file by clicking left or right side of ◀U▶ icon or pressing Ctrl+Alt+Left or Right arrow." & @CRLF & @CRLF & _
	"If you click the center of ◀U▶ icon, the letter U will be changed to 0 and the current file will be repeated until you click it back to U or select another file to play. This function can also be implemented by pressing Ctrl+Alt+r. If you loaded only one file, that file will be repeated regardless of the repeat status. If you want to repeat certain portion of the current file, you can click the current media position label (at the left side of slider) and set the start and end positions in seconds or mm:ss format. If set, the corresponding portion of the slider will turn to pink color. If you want to repeat certain files out of a large playlist, you can click the total media length label (at the right side of slider) and set the files to repeat. If set, the playlist will be reloaded with corresponding items displayed in pink background. While this function is in effect, shuffle, sort and rescan functions will be disabled for an obvious reason." & @CRLF & @CRLF & _
	"The program audio volume can be increased or decreased by clicking ▲ or ▼ icon or by pressing Ctrl+Alt+Up or Down arrow. The volume will be adjusted by 10 percentage points per click, the result appearing in a tooltip near the icon. The sound can be muted or unmuted by clicking 🔊/🔇 icon or pressing Ctrl+Alt+m. Windows Volume Mixer settings page may also be used to change volumes or to mute the sound." & @CRLF & @CRLF & _
	"If your computer has Intel CPU and Intel HD Graphics Control Panel, the Windows uses Ctrl+Alt+Arrow hotkeys to rotate the screen orientation. You can either disable screen rotation keyboard shorcuts in the PC Settings app or use alternate hotkey combinations in which arrows have been replaced with following keys: up arrow with equals(=) key, down arrow with minus(-) key, left arrow with comma(,) key and right arrow with period(.) key." & @CRLF & @CRLF & _
	"If you press Ctrl+Alt+i, your default browser will show the result of internet search on the current file." & @CRLF & @CRLF & _
	"The progress of playback is displayed in both graphics and text. You can navigate to a different playback position by clicking and dragging the small rectangular progress bar along the slider or by clicking anywhere on the slider." & @CRLF & @CRLF & _
	"By pressing Ctrl+Alt+w anytime, you can move all GUIs to their default positions and bring them up to foreground. The video window will be resized to its default size so that the main GUI is not blocked by the video." & @CRLF & @CRLF & _
	"If you press hotkeys to change folder, display playlist, help, or file properties window while video is playing in fullscreen, the video is reduced to maximized window and make it a non-top window." & @CRLF & @CRLF & _
	"You can terminate the program by clicking the main GUI Close button or 🞭 icon on the video control, or by pressing Ctrl+Alt+End. If a folder was loaded at the time of termination, zPlayer.ini file is created in the script directory where all the playback environment settings are saved including the folder name, playing order (shuffled or sorted), audio volume, etc. The player will resume these settings in the next session." & @CRLF & @CRLF & _
	"Winmm.dll which powers this player, can intrinsically play back mp3, wma, wav, asf, avi and wmv files, and additional codecs are required to play back other file types. Initially the playlist will include mp3, wav, wma, ogg, ape, flac, asf, mp4, wmv, avi, mkv, flv and webM files in the selected folder. Additional file formats you want to include in the playlist should be added in zPlayer.ini file under File Types key. You can also play back a whole audio CD via Load Folder or individual tracks in a CD via Load File." & @CRLF & @CRLF & _
	"Note: zPlayer is the name I used when I introduced the early version of this player in my blog back in early 2009 and, therefore, has nothing to do with the mobile media player of the same name which started marketing in 2015."
	Return $sText
EndFunc		;==>zPlayerHelp

#Region		;***** Functions for ISimpleAudioVolume Interface
; https://www.autoitscript.com/forum/topic/211638-how-can-i-getset-mute-state-of-windows-volume-mixer/?do=findComment&comment=1531412

Func _GetProcessID_by_name($process_name, $nTh)	; Get process ID from process anme
    Local $Process_list = ProcessList()
    Local $ProcessID_Func = 0, $n = 0
    For $i = UBound($Process_list)-1 To 1 Step -1
        If $Process_list[$i][0] = $process_name Then
			$n += 1
			If $n = $nTh Then
				$ProcessID_Func = $Process_list[$i][1]
				ExitLoop
			EndIf
        EndIf
    Next
	Return  $ProcessID_Func
EndFunc   ;==>_GetProcessID_by_name

Func _Audio_Action($action, $pid, $value)	; Each action takes about 6 milliseconds
    If Not IsObj($__oIAudioSessionManager2) Then
        $__oIAudioSessionManager2 = _Audio_GetIAudioSessionManager2()
    EndIf
    If Not IsObj($__oIAudioSessionManager2) Then Return

    Local $pIAudioSessionEnumerator, $oIAudioSessionEnumerator
    If $__oIAudioSessionManager2.GetSessionEnumerator($pIAudioSessionEnumerator) < 0 Then Return
    $oIAudioSessionEnumerator = ObjCreateInterface($pIAudioSessionEnumerator, $sIID_IAudioSessionEnumerator, $sTagIAudioSessionEnumerator)
    If Not IsObj($oIAudioSessionEnumerator) Then Return SetError(1)

    Local $i, $nSessions, $pIAudioSessionControl2, $oIAudioSessionControl2
    Local $ProcessID, $oISimpleAudioVolume
    Local $error = 1
    If $oIAudioSessionEnumerator.GetCount($nSessions) >= 0 Then
        For $i = 0 To $nSessions - 1
            If $oIAudioSessionEnumerator.GetSession($i, $pIAudioSessionControl2) >= 0 Then
                $oIAudioSessionControl2 = ObjCreateInterface($pIAudioSessionControl2, $sIID_IAudioSessionControl2, $sTagIAudioSessionControl2)
                If @error Then ContinueLoop
                $oIAudioSessionControl2.GetProcessId($ProcessID)
                If $ProcessID = $pid Then
                    $oISimpleAudioVolume = ObjCreateInterface($pIAudioSessionControl2, $sIID_ISimpleAudioVolume, $sTagISimpleAudioVolume)
                    If @error Then ContinueLoop
                    $oIAudioSessionControl2.AddRef() ;stabilize
					Switch $action
						Case "SetMute"
							If $oISimpleAudioVolume.SetMute($value, Null) >= 0 Then
								$error = 0
								ExitLoop
							EndIf
						Case "GetMute"
							If $oISimpleAudioVolume.GetMute($value) >= 0 Then
								$error = 0
								ExitLoop
							EndIf
;~ 						Case "SetVolume"
;~ 							If $oISimpleAudioVolume.SetMasterVolume($value, 0) >= 0 Then
;~ 								$error = 0
;~ 								ExitLoop
;~ 							EndIf
;~ 						Case "GetVolume"
;~ 							If $oISimpleAudioVolume.GetMasterVolume($value) >= 0 Then
;~ 								$error = 0
;~ 								ExitLoop
;~ 							EndIf
					EndSwitch
                EndIf
            EndIf
        Next
    EndIf
    $oISimpleAudioVolume = 0
    $oIAudioSessionControl2 = 0
    $oIAudioSessionEnumerator = 0
    Return SetError($error, 0, $value)
EndFunc   ;==>_Audio_Action

Func _Audio_GetIAudioSessionManager2()	; Used in _AudioAction()
    Local $oIAudioSessionManager2 = 0
    Local Const $eMultimedia = 1, $CLSCTX_INPROC_SERVER = 0x01
    Local $pIMMDevice, $oMMDevice, $pIAudioSessionManager2
    Local $oMMDeviceEnumerator = ObjCreateInterface($sCLSID_MMDeviceEnumerator, $sIID_IMMDeviceEnumerator, $sTagIMMDeviceEnumerator)
    If IsObj($oMMDeviceEnumerator) Then
        If $oMMDeviceEnumerator.GetDefaultAudioEndpoint(0, $eMultimedia, $pIMMDevice) >= 0 Then
            $oMMDevice = ObjCreateInterface($pIMMDevice, $sIID_IMMDevice, $sTagIMMDevice)
            If IsObj($oMMDevice) Then
                If $oMMDevice.Activate(_CLSIDFromString($sIID_IAudioSessionManager2), $CLSCTX_INPROC_SERVER, 0, $pIAudioSessionManager2) >= 0 Then
                    $oIAudioSessionManager2 = ObjCreateInterface($pIAudioSessionManager2, $sIID_IAudioSessionManager2, $sTagIAudioSessionManager2)
                EndIf
                $oMMDevice = 0
            EndIf
        EndIf
        $oMMDeviceEnumerator = 0
    EndIf

    If IsObj($oIAudioSessionManager2) Then
        Return $oIAudioSessionManager2
    EndIf
EndFunc   ;==>_Audio_GetIAudioSessionManager2

Func _CLSIDFromString($sGUID)	; Used in _Audio_GetIAudioSessionManager2()
    Local $tGUID = DllStructCreate("ulong Data1;ushort Data2;ushort Data3;byte Data4[8]")
    DllCall("ole32.dll", "long", "CLSIDFromString", "wstr", $sGUID, "struct*", $tGUID)
    Return $tGUID
EndFunc   ;==>CLSIDFromString
#EndRegion		;***** Functions for ISimpleAudioVolume Interface